#ifndef TIME_H
#define TIME_H
#define CLOCK_TICKS_PER_SECOND 60
typedef long cputim_t;
extern cputim_t cputim();
#endif

#define UTIME (tbufb.ut - tbufa.ut + tbufb.cut - tbufa.cut)
#define STIME (tbufb.st - tbufa.st + tbufb.cst - tbufa.cst)

typedef struct tbuf {
   long ut, st;
   long cut, cst;
} TBUF;

long times();

/*
 * cputim - return (in ticks) CPU time since last call
 */

long cputim()
{
   long ret;
   long ut1, st1, i;
   static TBUF tbufa = {0, 0, 0, 0};
   static TBUF tbufb = {0, 0, 0, 0};

   times(&tbufb);
   ut1 = UTIME;
   st1 = STIME;
   ret = (ut1 + st1);

   tbufa = tbufb;
   return (ret);
}


