
BEGIN {  
   espon[0]=1;
   espon[1]=16;
   espon[2]=256;
   espon[3]=4096;
   espon[4]=65536;
   espon[5]=1048576;
   espon[6]=16777216;
   espon[7]=268435456;
   first = 1;
   header_written = 0;
}

{
   if ( !header_written ) {
      printf("\n# Cache information for task %s\n\n", FILENAME);
      header_written = 1;
   }
   if (substr($3,1,1) == "L") {
      value = 0;
      for (i=5; i>=0; i--) {
         value += hex(substr($2,8-i,1))*espon[i];
      }
      if (!first) {
         printf("\t%x\n\n", value-2);
      }
      node = substr($3,2);
      printf("NODE\t%s\n", node);
      printf("ADDR\t%x", value);
      if ( node == 0 ) {
         printf("\t%x\n\n", value+4);
         printf("SIZE\t%x\n", value+4);
         exit;
      }
      first = 0;
   }
}

function hex(a) {
    
    if (a=="a")
       return 10;
    else if (a=="b")
       return 11;
    else if (a=="c")
       return 12;
    else if (a=="d")
       return 13;
    else if (a=="e")
       return 14;
    else if (a=="f")
       return 15;
    else 
       return a;
}
