
static int *cache_tags = NULL;
static int *data_cache = NULL;

static void 
set_cache_tag( int *cache, int line, int tag ) {
   cache[line] = tag;
}

static int 
get_cache_tag( int *cache, int line ) {
   return cache[line];
}

int *create_cache(int num_cache_lines){
   int i;
   int *tmp;
   tmp = (int *)malloc(sizeof(int) * (NUM_CACHE_LINES));
   
   if ( tmp != NULL ) {
            for (i=0; i < NUM_CACHE_LINES; i++) {
               set_cache_tag( tmp, i, -1 );
            }
/*
            i = time(NULL);
            srand(i);
*/
   }
         else {
            fprintf(stderr, "Error in create_cache\n");
            exit(1);
         }
   
   return tmp;
}


static int 
addr_to_line( int addr ) {
   return (( addr/LINESIZE ) % NUM_CACHE_SETS) * ASSOCIATIVITY;
}

static int 
present_in_set( int *cache, int addr ) {
   int i, addr1;

   i = addr_to_line(addr) + ASSOCIATIVITY - 1;
   addr1 = addr&LINESIZE_MASK;

   while ( i >= addr_to_line( addr ) ) {
      if ( get_cache_tag( cache, i ) == addr1 )
         return TRUE;
      i--;
   }
   return FALSE;
}

void 
print_cache( int *cache ) {
   int i;

   printf("Cache:\n");
   for( i=0; i < NUM_CACHE_LINES; i++ ) {
      printf("%d ", get_cache_tag( cache, i ) );
      if ( i%16 == 15 ) printf("\n"); 
   }
   printf("\n");
}

static void
insert_in_set( int *cache, int addr ) {
   static i=0;

   set_cache_tag( cache, addr_to_line(addr) +i, addr&LINESIZE_MASK );
   i=rand() % ASSOCIATIVITY;
}

int 
put_in_cache( int *cache, i_fetch_list_t *i_fetch_list ) {
   int addr;
   int n_hit = 0;
   /*i_fetch_list_t *i_fetch_list;

      set_hit_rate( node, 1.0 ); 

   i_fetch_list = get_i_fetch_list( node ); */

   while ( i_fetch_list != NULL ) {

      addr = get_i_fetch_addr( i_fetch_list );
      if ( present_in_set( cache, addr ) ) {
         /*fprintf(stderr, "addr=%d  hit\n", addr);*/
         n_hit++;
      }
      else { 
         /*fprintf(stderr, "addr=%d  miss\n", addr);*/
         insert_in_set( cache, addr );
      }
      i_fetch_list = get_next_i_fetch( i_fetch_list );
   }
   return n_hit;  
}
