
#ifdef UNIX 

  for( done=0; !done; ) {

      /* read command line */
      printf("\n\nos sim> ");
      fflush (stdout);
      sslinep = ssline;
      while ((cc = (fgetc(stdin))) != ';') { 
         if (cc == EOF) {
#ifdef DO_DELAY
           _end_monitor ();
#endif /*DO_DELAY*/
           exit (0);
         }
         *sslinep = cc;
         sslinep++;
      }
      *sslinep = ' ';
      sslinep++;
      *sslinep = ';';
      sslinep++;
      *sslinep = '\0';


      sslinep = strtok(ssline, " \n\t\v");

      if (! strcmp (sslinep, "_newfile")) {
		ss = strtok(NULL, " \n\t\v");
		sscanf (sslinep + 9, "%s", ss);
		if (! strlen (ss)) {
			exit(1);
		}
		if (ss[strlen(ss) - 1] == ';') {
			ss[strlen(ss) - 1] = '\0';
		}
		if (freopen (ss, "r", stdin) == NULL) {
			perror (ssline);
			exit (1);
		}

      } else  if( ! strcmp(sslinep, "_show") || 
		      ! strcmp(sslinep, "_hide")) {
            if(  ! strcmp(sslinep, "_show"))  new_val = 1;
	    else                              new_val = 0;

            while(*(ss = strtok(NULL, " \n\t\v")) != ';' ) {

	      if(! strcmp(ss, "cfsms")) {
		_show_cfsms = new_val;
	      } else if(! strcmp(ss, "os")) { 
		_show_os = new_val;
	      } else if(! strcmp(ss, "internals")) { 
		_show_internals = new_val;
	      } else if(! strcmp(ss, "values")) { 
		_show_values = new_val;
	      } else if(! strcmp(ss, "inputs")) { 
		_show_inputs = new_val;
              } else if(! strcmp(ss, "all")) {
		_show_cfsms = new_val;
		_show_os = new_val;
		_show_internals = new_val;
		_show_values = new_val;
		_show_inputs = new_val;
              } else if(! strcmp(ss, "status")) {
		printf("\nSHOW CFSMS \t%s\n", _show_cfsms?"ON":"OFF");
		printf("SHOW OS \t%s\n", _show_os?"ON":"OFF");
		printf("SHOW INTERNALS \t%s\n", _show_internals?"ON":"OFF");
		printf("SHOW VALUES \t%s\n", _show_values?"ON":"OFF");
		printf("SHOW INPUTS \t%s\n", _show_inputs?"ON":"OFF");
		
	      } else {
		printf("\n WARNING: %s ignored, not a valid option to %s \n"
		, ss, sslinep);
	      }
            }

      } else if (! strcmp (sslinep, "_cache_size")) {
                ss = strtok(NULL, " \n\t\v");
                sscanf (sslinep + 12, "%s", ss);
                printf("new CACHESIZE\n");
                if (! strlen (ss)) {
                        exit(1);
                }
                itemp = atoi( ss );
                set_cache_size( itemp );
                printf("set_cache_size(%d) \n", itemp);

                fprintf(stderr, "CACHESIZE= %d\n", CACHESIZE);
                fprintf(stderr, "LINESIZE= %d\n", LINESIZE);
                fprintf(stderr, "ASSOCIATIVITY= %d\n", ASSOCIATIVITY);
                fprintf(stderr, "NUM_CACHE_LINES= %d\n", NUM_CACHE_LINES);
                fprintf(stderr, "NUM_CACHE_SETS= %d\n", NUM_CACHE_SETS);
                fprintf(stderr, "HISTORY_LENGTH= %d\n", HISTORY_LENGTH);
                fprintf(stderr, "THRESHOLD= %.2f\n", THRESHOLD);

                fclose( fptraces );

                free_history_cache();
                alloc_history_cache( );
                /* init_cache( csimulstyle ); */

                update_addresses( get_task_sgraph(get_task(0)), 9);
                update_addresses( get_task_sgraph(get_task(1)), 8);

                fptraces = fopen( "traces.txt", "w" );
                setbuf ( fptraces, NULL );

                history_pos = 0;
                n_instr_fetch = 0;
                n_instr_hit  = 0;
/*
                curr_layout = NULL;
                temp_layout = NULL;
*/

                init_hw();
                init_sw();

                get_monitor_events();

                set_init_values();
                emit_init_events();
                #ifdef ESTEREL
                emit_tick();
                #endif /* ESTEREL */

                /* run every task once */
                for(p=0; p<N_PROCS; p++) {
                   printf("run task(%d) \n", p);
                   task_exec(p);
                }

      } else {
	    
        done = 1;

        if(_show_inputs) printf("\nINPUT: ");
 
      /* read event (and possibly value) */

        for(ss=sslinep; *ss != ';'; ss = strtok(NULL, " \n\t\v")) {

         /* find and set event */
         vss = ss;
         ssval = strchr(ss, '(');
         if (ssval != NULL)  *ssval = '\0'; 
         ee = find_event(ss, /*silent*/ 0);
         if (ee != -1) {
#ifdef DO_DELAY
                        if (check_event[ee]) { _monitor_event (ee); }
#endif /*DO_DELAY*/
                        if (debug_event_value_name[ee] != 0x0) {
                           vss = debug_event_value_name[ee];
                        } else {
                           *ss = '\0';
                        }
         }

         /* set value if required */
         if (ssval != NULL) {
            ssval++;
            *strchr(ssval, ')') = '\0';
       	    if (!strcmp (ssval, "true")) {
		ssval = "1";
	    } else if (!strcmp (ssval, "false")) {
		ssval = "0";
	    }


	    if(debug_event_value_name[ee] != (char*)0) {
	      set_value(debug_event_value_name[ee], ssval);

              if(_show_inputs) printf("%s(%s) ",debug_event_value_name[ee],
	                                       ssval);

            } else {
	      printf("Warning: %d is pure event, value ignored\n",
	       debug_event_value_name[ee]);
            }
         }
	 if(ee != -1) {
	   if(event_iv_port[ee] != (int8bit*) 0) {
             *event_iv_port[ee] = *event_iv_port[ee] | event_iv_bit[ee];
             if(_show_inputs) printf("%s ",debug_event_name[ee]);

	   } else if(intr_table[ee] != (f_intr_p_t)0) {
	     (*intr_table[ee])();
             if(_show_inputs) printf("%s ",debug_event_name[ee]);

           } else {
	     printf("\n %s is not a valid input event name\n",
		     debug_event_name[ee]);
           }
         }
        } /* end parsing line with events */
      } /* end parsing line */
   } /* end reading lines */

   if(!_show_cfsms && !_show_os && 
      (_show_inputs || _show_values || _show_internals)) {
     printf("\n%sOUTPUTS: ",_show_internals? "INTERNALS AND ":"");
   }

#endif /*UNIX*/


