.\" /*
.\"  * Revision Control Information
.\"  *
.\"  * $Source: /projects/hwsw/hwsw/common/src/polis/polis_lib/help/ptlconst.man,v $
.\"  * $Author: luciano $
.\"  * $Revision: 1.2 $
.\"  * $Date: 1996/08/21 15:38:17 $
.\"  *
.\"
.TH PTLCONST 1CAD "1 August 1994"
.SH NAME
ptlconst \- Update star parameters in Ptolemy
.SH SYNOPSIS
.B ptlconst filename
.SH DESCRIPTION
\fBptlconst\fR updates the parameters of Ptolemy database
cells using the information in the given file. 
The format of the file is as follows:
.PP
 cell mod1
   define is_SW 1
   define UP_LEVEL UP_LEVEL
  instance mod2 mod2_inst1 
   define is_SW is_SW
   define priority 0
   define CONST_123 123
   define LEVEL UP_LEVEL
 ...
  instance mod2 mod3_inst2 
   define is_SW 0
   define MAX 10
 ...
.PP
\fBcell\fP 
introduces the ptolemy galaxy name where the parameters must be updated. 

\fBinstance\fP introduces the ptolemy master and instance name 
whose parameters must be updated.
Instance names can be obtained within \fIpigi\fP
by using the \fIname\fP (or \fIn\fP) command.

\fBdefine\fP introduces the parameter name and value.
The \fIis_SW\fP parameter (that \fImust be\fP specified) 
defines the implementation choice for the
given instance. 

If the value of any parameter is a string, then a
parameter with that name must exist in the instantiating galaxy, and the value
of the parameter is propagated from the upper levels of the hierarchy.
.PP
Note that \fIptlconst\fP updates \fIall\fP the parameters of a given star
instance. Partial updates can be done 
with the \fIedit-params\fP (or \fIe\fP)
command in \fIpigi\fP. Alternatively one could use
\fIptl2shift\fP with the \fB-P\fP option
to print out the old parameter
values, edit the file appropriately and update them by using \fIptlconst\fP.
.SH "SEE ALSO"
ptl2shift
.SH AUTHORS
Luciano Lavagno
.SH BUGS
.SH COMMENTS
