BEGIN {
#	bufname ="BUF"
#	print >"defines"
}
/^1 1/ {
	next
}
/\.end/ {
	printf "endmodule\n"
	next
}
/\.model/ {
	printf "module %s (", $2
	next
}
/\.inputs/ {
	do_inputs = 1
	do_outputs = 0
	do_latch = 0
	do_gate = 0
	do_names = 0
}
/\.outputs/ {
	do_inputs = 0
	do_outputs = 1
	do_latch = 0
	do_gate = 0
	do_names = 0
}
/\.mlatch/ {
	do_inputs = 0
	do_outputs = 0
	do_latch = 1
	do_gate = 0
	do_names = 0
}
/\.gate/ {
	do_inputs = 0
	do_outputs = 0
	do_latch = 0
	do_gate = 1
	do_names = 0
}
/\.names/ {
	do_inputs = 0
	do_outputs = 0
	do_latch = 0
	do_gate = 0
	do_names = 1
}
/\.default/ {
	do_inputs = 0
	do_outputs = 0
	if (!done_decl) {
		done_decl = 1
		for (i = 1; i <= incnt; i++) {
			printf "%s, ", inputs[i]
		}
		for (i = 1; i < outcnt; i++) {
			printf "%s, ", outputs[i]
		}
		printf "%s );\n", outputs[outcnt]

		for (i = 1; i <= incnt; i++) {
			if (maxindex[inputs[i]] || minindex[inputs[i]]) {
				printf "input [%d:%d] %s;\n", maxindex[inputs[i]], \
					minindex[inputs[i]], inputs[i]
			}
			else {
				printf "input %s;\n", inputs[i]
			}
		}
		for (i = 1; i <= outcnt; i++) {
			if (maxindex[outputs[i]] || minindex[outputs[i]]) {
				printf "output [%d:%d] %s;\n", maxindex[outputs[i]], \
					minindex[outputs[i]], outputs[i]
			}
			else {
				printf "output %s;\n", outputs[i]
			}
		}
	}
	next
}
{
	nf = NF - 1
	if ($NF != "\\") {
		nf = NF
	}
	if (do_inputs || do_outputs) {
		for (i = 2; i <= nf; i++) {
			if ($i ~ /\[[0-9]*\]/) {
				num = substr ($i, 2, length($i)-2)
				if (num + 1 > maxindex[prev] + 1) maxindex[prev] = num
				if (num + 1 < minindex[prev] + 1) minindex[prev] = num
			} 
			else {
				prev = $i
				if (do_inputs && ! intab[$i]) {
					intab[$i] = 1
					incnt++
					inputs[incnt] = $i
				}
				if (do_outputs && ! outtab[$i]) {
					outtab[$i] = 1
					outcnt++
					outputs[outcnt] = $i
				}
			}
		}
	}
	else if (do_latch) {
		printf "%s i%d (", $2, icnt++
		for (i = 3; i < NF - 4; i+=2) {
			if ($(i+2) ~ /\[[0-9]*\]/) {
				if (maxindex[$(i+1)] || minindex[$(i+1)]) {
					printf ".%s(%s%s), ", $i, $(i+1), $(i+2)
				}
				else {
					printf ".%s(%s_%s_), ", $i, $(i+1), \
						substr ($(i+2), 2, length($(i+2)) - 2)
				}
				i++
			}
			else {
				printf ".%s(%s), ", $i, $(i+1)
			}
		}
		if ($(NF-2) ~ /\[[0-9]*\]/) {
			if (maxindex[$(NF-3)] || minindex[$(NF-3)]) {
				printf ".%s(%s%s));\n", $(NF-4), $(NF-3), $(NF-2)
			}
			else {
				printf ".%s(%s_%s_));\n", $(NF-4), $(NF-3), \
					substr ($(NF-2), 2, length($(NF-2)) - 2)
			}
		}
		else {
			printf ".%s(%s));\n", $(NF-3), $(NF-2)
		}
	}
	else if (do_gate) {
		printf "%s i%d (", $2, icnt++
		for (i = 3; i < NF - 2; i+=2) {
			if ($(i+2) ~ /\[[0-9]*\]/) {
				if (maxindex[$(i+1)] || minindex[$(i+1)]) {
					printf ".%s(%s%s), ", $i, $(i+1), $(i+2)
				}
				else {
					printf ".%s(%s_%s_), ", $i, $(i+1), \
						substr ($(i+2), 2, length($(i+2)) - 2)
				}
				i++
			}
			else {
				printf ".%s(%s), ", $i, $(i+1)
			}
		}
		if ($(NF) ~ /\[[0-9]*\]/) {
			if (maxindex[$(NF-1)] || minindex[$(NF-1)]) {
				printf ".%s(%s%s));\n", $(NF-2), $(NF-1), $(NF)
			}
			else {
				printf ".%s(%s_%s_));\n", $(NF-2), $(NF-1), \
					substr ($(NF), 2, length($(NF)) - 2)
			}
		}
		else {
			printf ".%s(%s));\n", $(NF-1), $(NF)
		}
	}
	else if (do_names) {
		if (NF != 3) {
			print "Error: must use write_blif -n !!"
		}
		else {
			printf "wire "
			if ($(NF) ~ /\[[0-9]*\]/) {
				if (maxindex[$(NF-1)] || minindex[$(NF-1)]) {
					printf "%s%s = ", $(NF-1), $(NF)
				}
				else {
					printf "%s_%s_ = ", $(NF-1), \
						substr ($(NF), 2, length($(NF)) - 2)
				}
			}
			else {
				printf "%s = ", $(NF)
			}
			if ($(3) ~ /\[[0-9]*\]/) {
				if (maxindex[$(2)] || minindex[$(2)]) {
					printf "%s%s;\n", $(2), $(3)
				}
				else {
					printf "%s_%s_;\n", $(2), \
						substr ($(3), 2, length($(3)) - 2)
				}
			}
			else {
				printf "%s;\n", $(2)
			}
		}
#		printf "s/" >"defines"
#		if ($(NF) ~ /\[[0-9]*\]/) {
#			if (maxindex[$(NF-1)] || minindex[$(NF-1)]) {
#				printf "%s%s", $(NF-1), $(NF) >"defines"
#			}
#			else {
#				printf "%s_%s_", $(NF-1), \
#					substr ($(NF), 2, length($(NF)) - 2) >"defines"
#			}
#		}
#		else {
#			printf "%s", $(NF) >"defines"
#		}
#		printf "/" >"defines"
#		if ($(3) ~ /\[[0-9]*\]/) {
#			if (maxindex[$(2)] || minindex[$(2)]) {
#				printf "%s%s", $(2), $(3) >"defines"
#			}
#			else {
#				printf "%s_%s_", $(2), \
#					substr ($(3), 2, length($(3)) - 2) >"defines"
#			}
#		}
#		else {
#			printf "%s", $(2) >"defines"
#		}
#		printf "/\n" >"defines"
	}
	if (do_inputs) {
		if ($NF != "\\") {
			do_inputs = 0
		}
	}
	if (do_outputs) {
		if ($NF != "\\") {
			do_outputs = 0
		}
	}
	if (do_gate) {
		if ($NF != "\\") {
			do_gate = 0
		}
	}
	if (do_latch) {
		if ($NF != "\\") {
			do_latch = 0
		}
	}
}
