--/*
-- ROUTINES: for synthesis support of shift2vhdl
-- Author: Bassam Tabbara (tbassam@ic.eecs)
--
-- VHDL routine Library for uC SW LIB 
--
--

--library IEEE;
--use IEEE.std_logic_arith.all;
--library STD;
--use STD.STANDARD.all; 

library WORK;
use WORK.numeric_bit.all; --numeric_bit provided with release
-- package declaration
package uC_routines_synth_pkg is

function uITE(i0: in UNSIGNED; 
	       i1: in integer; 
               i2: in integer) return integer;
function uWIRE(i0: in integer) return integer;
function uWIRE(i0: in UNSIGNED) return UNSIGNED;
function uWIRE(i0: in SIGNED) return SIGNED;
function uADD(i0: in integer;
               i1: in integer) return integer;
function uADD(i0: in SIGNED;
               i1: in SIGNED) return SIGNED;
function uADD(i0: in UNSIGNED;
               i1: in UNSIGNED) return UNSIGNED;
function uSUB(i0: in integer;
               i1: in integer) return integer;
function uSUB(i0: in SIGNED;
               i1: in SIGNED) return SIGNED;
function uSUB(i0: in UNSIGNED;
               i1: in UNSIGNED) return SIGNED;
function uINC(i0: in integer) return integer;
function uINC(i0: in SIGNED) return SIGNED;
function uINC(i0: in UNSIGNED) return UNSIGNED;
function uDEC(i0: in integer) return integer;
function uDEC(i0: in SIGNED) return SIGNED;
function uDEC(i0: in UNSIGNED) return SIGNED;
function uGT(i0: in integer;
              i1: in integer) return UNSIGNED;
function uGT(i0: in SIGNED;
              i1: in SIGNED) return UNSIGNED;
function uGT(i0: in UNSIGNED;
              i1: in UNSIGNED) return UNSIGNED;
function uGE(i0: in integer;
              i1: in integer) return UNSIGNED;
function uGE(i0: in SIGNED;
              i1: in SIGNED) return UNSIGNED;
function uGE(i0: in UNSIGNED;
              i1: in UNSIGNED) return UNSIGNED;
function uLT(i0: in integer;
              i1: in integer) return UNSIGNED;
function uLT(i0: in SIGNED;
              i1: in SIGNED) return UNSIGNED;
function uLT(i0: in UNSIGNED;
              i1: in UNSIGNED) return UNSIGNED;
function uLE(i0: in integer;
              i1: in integer) return UNSIGNED;
function uLE(i0: in SIGNED;
              i1: in SIGNED) return UNSIGNED;
function uLE(i0: in UNSIGNED;
              i1: in UNSIGNED) return UNSIGNED;
function uEQ(i0: in integer;
              i1: in integer) return UNSIGNED;
function uEQ(i0: in SIGNED;
              i1: in SIGNED) return UNSIGNED;
function uEQ(i0: in UNSIGNED;
              i1: in UNSIGNED) return UNSIGNED;
function uNEQ(i0: in integer;
               i1: in integer) return UNSIGNED;
function uNEQ(i0: in SIGNED;
               i1: in SIGNED) return UNSIGNED;
function uNEQ(i0: in UNSIGNED;
               i1: in UNSIGNED) return UNSIGNED;

-- /* Boolean AND, OR, NOT, NAND, NOR, XOR, XNOR */
function uBOOL_AND(i0: in UNSIGNED;
              i1: in UNSIGNED) return UNSIGNED;
function uBOOL_OR(i0: in UNSIGNED;
              i1: in UNSIGNED) return UNSIGNED;
function uBOOL_NOT(i0: in UNSIGNED) return UNSIGNED;
function uBOOL_NAND(i0: in UNSIGNED;
              i1: in UNSIGNED) return UNSIGNED;
function uBOOL_NOR(i0: in UNSIGNED;
              i1: in UNSIGNED) return UNSIGNED;
function uBOOL_XOR(i0: in UNSIGNED;
              i1: in UNSIGNED) return UNSIGNED;
function uBOOL_XNOR(i0: in UNSIGNED;
              i1: in UNSIGNED) return UNSIGNED;

-- /* Logical AND, OR, NOT, NAND, NOR, XOR, XNOR */
function uBOOL_AND(i0: in integer;
              i1: in integer) return UNSIGNED;
function uBOOL_OR(i0: in integer;
              i1: in integer) return UNSIGNED;
function uBOOL_NOT(i0: in integer) return UNSIGNED;
function uBOOL_NOT(i0: in integer) return integer;
function uBOOL_NAND(i0: in integer;
              i1: in integer) return UNSIGNED;
function uBOOL_NOR(i0: in integer;
              i1: in integer) return UNSIGNED;
function uBOOL_XOR(i0: in integer;
              i1: in integer) return UNSIGNED;
function uBOOL_XNOR(i0: in integer;
              i1: in integer) return UNSIGNED;

-- /* Logical AND, OR, NOT, NAND, NOR, XOR, XNOR */
function uBOOL_AND(i0: in UNSIGNED;
              i1: in integer) return UNSIGNED;
function uBOOL_AND(i0: in integer;
              i1: in UNSIGNED) return UNSIGNED;
function uBOOL_OR(i0: in UNSIGNED;
              i1: in integer) return UNSIGNED;
function uBOOL_OR(i0: in integer;
              i1: in UNSIGNED) return UNSIGNED;
function uBOOL_NAND(i0: in UNSIGNED;
              i1: in integer) return UNSIGNED;
function uBOOL_NAND(i0: in integer;
              i1: in UNSIGNED) return UNSIGNED;
function uBOOL_NOR(i0: in UNSIGNED;
              i1: in integer) return UNSIGNED;
function uBOOL_NOR(i0: in integer;
              i1: in UNSIGNED) return UNSIGNED;
function uBOOL_XOR(i0: in UNSIGNED;
              i1: in integer) return UNSIGNED;
function uBOOL_XOR(i0: in integer;
              i1: in UNSIGNED) return UNSIGNED;
function uBOOL_XNOR(i0: in UNSIGNED;
              i1: in integer) return UNSIGNED;
function uBOOL_XNOR(i0: in integer;
              i1: in UNSIGNED) return UNSIGNED;

-- /* Bitwise AND, OR, NOT, NAND, NOR, XOR, XNOR :operate on unsigned's */
function uAND(i0: in unsigned;
              i1: in unsigned) return unsigned;
function uOR(i0: in unsigned;
              i1: in unsigned) return unsigned;
function uNOT(i0: in unsigned) return unsigned;
function uNAND(i0: in unsigned;
              i1: in unsigned) return unsigned;
function uNOR(i0: in unsigned;
              i1: in unsigned) return unsigned;
function uXOR(i0: in unsigned;
              i1: in unsigned) return unsigned;
function uXNOR(i0: in unsigned;
              i1: in unsigned) return unsigned;

function uLSH(i0: in unsigned;
               i1: in integer) return unsigned;
function uLSH1(i0: in unsigned) return unsigned;
function uRSH(i0: in unsigned;
               i1: in integer) return unsigned;
function uRSH1(i0: in unsigned) return unsigned;
function uRSH8(i0: in unsigned) return unsigned;

function uLSH(i0: in integer;
               i1: in integer) return integer;
function uLSH1(i0: in integer) return integer;
function uRSH(i0: in integer;
               i1: in integer) return integer;
function uRSH1(i0: in integer) return integer;
function uRSH8(i0: in integer) return integer;

function uCPL2(i0: in signed) return signed;
function uU_MINUS(i0: in integer) return integer;
function uTIMES(i0: in integer;
               i1: in integer) return integer;
function uDIVIDE(i0: in integer;
                  i1: in integer) return integer;
function uMOD(i0: in integer;
               i1: in integer) return integer;
function uMINUS(i0: in integer;
                 i1: in integer) return integer;
function uMUL(i0: in integer;
               i1: in integer) return integer;
function uTIME(i0: in integer;
               i1: in integer) return integer;
end uC_routines_synth_pkg;

--library IEEE;
--use IEEE.std_logic_arith.all;
library WORK;
use WORK.numeric_bit.all; --numeric_bit provided with release
--package body
package body uC_routines_synth_pkg is

function uITE(i0: in UNSIGNED; 
	       i1: in integer; 
               i2: in integer) return integer is
-- performs ((i0)?(i1):(i2))
begin
	if (i0 = "1") then return i1;
	else return i2;
	end if;
end ;

function uWIRE(i0: in integer) return integer is  
-- performs ((i0)=(i1))
begin
	return i0;
end ;

function uWIRE(i0: in SIGNED) return SIGNED is  
-- performs ((i0)=(i1))
begin
	return i0;
end ;

function uWIRE(i0: in UNSIGNED) return UNSIGNED is  
-- performs ((i0)=(i1))
begin
	return i0;
end ;

function uADD(i0: in integer;
	       i1: in integer) return integer is
-- performs ((i0)+(i1))
begin
	return i0 + i1;
end ;

function uADD(i0: in SIGNED;
	       i1: in SIGNED) return SIGNED is
-- performs ((i0)+(i1))
begin
	return i0 + i1;
end ;

function uADD(i0: in UNSIGNED;
	       i1: in UNSIGNED) return UNSIGNED is
-- performs ((i0)+(i1))
begin
	return i0 + i1;
end ;

function uSUB(i0: in integer;
	       i1: in integer) return integer is
-- performs ((i0)-(i1))
begin
	return i0 - i1;
end ;

function uSUB(i0: in SIGNED;
	       i1: in SIGNED) return SIGNED is
-- performs ((i0)-(i1))
begin
	return i0 - i1;
end ;

function uSUB(i0: in UNSIGNED;
	       i1: in UNSIGNED) return SIGNED is
-- performs ((i0)-(i1))
begin
	return i0 - i1;
end ;

function uINC(i0: in integer) return integer is
-- performs ((i0)+1)
begin
	return i0 + 1;
end ;

function uINC(i0: in SIGNED) return SIGNED is
-- performs ((i0)+1)
begin
	return i0 + 1;
end ;

function uINC(i0: in UNSIGNED) return UNSIGNED is
-- performs ((i0)+1)
begin
	return i0 + 1;
end ;

function uDEC(i0: in integer) return integer is
-- performs ((i0)-1)
begin
	return i0 - 1;
end;

function uDEC(i0: in SIGNED) return SIGNED is
-- performs ((i0)-1)
begin
	return i0 - 1;
end;

function uDEC(i0: in UNSIGNED) return SIGNED is
-- performs ((i0)-1)
begin
	return i0 - 1;
end;

function uGT(i0: in integer;
	      i1: in integer) return UNSIGNED is
-- performs ((i0)>(i1))
begin
	if (i0 > i1) then return "1";
	else return "0";
	end if;
end;

function uGT(i0: in SIGNED;
	      i1: in SIGNED) return UNSIGNED is
-- performs ((i0)>(i1))
begin
	if (i0 > i1) then return "1";
	else return "0";
	end if;
end;

function uGT(i0: in UNSIGNED;
	      i1: in UNSIGNED) return UNSIGNED is
-- performs ((i0)>(i1))
begin
	if (i0 > i1) then return "1";
	else return "0";
	end if;
end;

function uGE(i0: in integer;
	      i1: in integer) return UNSIGNED is
-- performs ((i0)>=(i1))
begin
	if (i0 >= i1) then return "1";
	else return "0";
	end if;
end;

function uGE(i0: in SIGNED;
	      i1: in SIGNED) return UNSIGNED is
-- performs ((i0)>=(i1))
begin
	if (i0 >= i1) then return "1";
	else return "0";
	end if;
end;

function uGE(i0: in UNSIGNED;
	      i1: in UNSIGNED) return UNSIGNED is
-- performs ((i0)>=(i1))
begin
	if (i0 >= i1) then return "1";
	else return "0";
	end if;
end;

function uLT(i0: in integer;
	      i1: in integer) return UNSIGNED is
-- performs ((i0)<(i1))
begin
	if (i0 < i1) then return "1";
	else return "0";
	end if;
end;

function uLT(i0: in SIGNED;
	      i1: in SIGNED) return UNSIGNED is
-- performs ((i0)<(i1))
begin
	if (i0 < i1) then return "1";
	else return "0";
	end if;
end;

function uLT(i0: in UNSIGNED;
	      i1: in UNSIGNED) return UNSIGNED is
-- performs ((i0)<(i1))
begin
	if (i0 < i1) then return "1";
	else return "0";
	end if;
end;

function uLE(i0: in integer;
	      i1: in integer) return UNSIGNED is
-- performs ((i0)<=(i1))
begin
	if (i0 <= i1) then return "1";
	else return "0";
	end if;
end;

function uLE(i0: in SIGNED;
	      i1: in SIGNED) return UNSIGNED is
-- performs ((i0)<=(i1))
begin
	if (i0 <= i1) then return "1";
	else return "0";
	end if;
end;

function uLE(i0: in UNSIGNED;
	      i1: in UNSIGNED) return UNSIGNED is
-- performs ((i0)<=(i1))
begin
	if (i0 <= i1) then return "1";
	else return "0";
	end if;
end;

function uEQ(i0: in integer;
	      i1: in integer) return UNSIGNED is
-- performs ((i0)==(i1))
begin
	if (i0 = i1) then return "1";
	else return "0";
	end if;
end;

function uEQ(i0: in SIGNED;
	      i1: in SIGNED) return UNSIGNED is
-- performs ((i0)==(i1))
begin
	if (i0 = i1) then return "1";
	else return "0";
	end if;
end;

function uEQ(i0: in UNSIGNED;
	      i1: in UNSIGNED) return UNSIGNED is
-- performs ((i0)==(i1))
begin
	if (i0 = i1) then return "1";
	else return "0";
	end if;
end;

function uNEQ(i0: in integer;
	       i1: in integer) return UNSIGNED is
-- performs ((i0)!=(i1))
begin
	if (i0 /= i1) then return "1";
	else return "0";
	end if;
end;

function uNEQ(i0: in SIGNED;
	       i1: in SIGNED) return UNSIGNED is
-- performs ((i0)!=(i1))
begin
	if (i0 /= i1) then return "1";
	else return "0";
	end if;
end;

function uNEQ(i0: in UNSIGNED;
	       i1: in UNSIGNED) return UNSIGNED is
-- performs ((i0)!=(i1))
begin
	if (i0 /= i1) then return "1";
	else return "0";
	end if;
end;

-- /* Boolean AND, OR, NOT, NAND, NOR, XOR, XNOR */
function uBOOL_AND(i0: in UNSIGNED;
	      i1: in UNSIGNED) return UNSIGNED is
-- performs ((i0)&&(i1))
begin
	return i0 and i1;
end;

function uBOOL_OR(i0: in UNSIGNED;
	      i1: in UNSIGNED) return UNSIGNED is
-- performs ((i0)||(i1))
begin
	return i0 or i1;
end;

function uBOOL_NOT(i0: in UNSIGNED) return UNSIGNED is
-- performs (!(i0))
begin
	return not(i0);
end;

function uBOOL_NAND(i0: in UNSIGNED;
	      i1: in UNSIGNED) return UNSIGNED is
-- performs (!((i0)&&(i1)))
begin
	return not (i0 and i1); -- bug in synopsys v3.3b nand !?!?!
end;

function uBOOL_NOR(i0: in UNSIGNED;
	      i1: in UNSIGNED) return UNSIGNED is
-- performs (!((i0)||(i1)))
begin
	return i0 nor i1;
end;

function uBOOL_XOR(i0: in UNSIGNED;
	      i1: in UNSIGNED) return UNSIGNED is
-- performs ((i0)xor(i1))
begin
	return i0 xor i1;
end;

function uBOOL_XNOR(i0: in UNSIGNED;
	      i1: in UNSIGNED) return UNSIGNED is
-- performs (!((i0)xor(i1)))
begin
	return not(i0 xor i1);
end;

-- /* Logical AND, OR, NOT, NAND, NOR, XOR, XNOR */
function uBOOL_AND(i0: in integer;
	      i1: in integer) return UNSIGNED is
-- performs ((i0)&&(i1))
begin
  if ((i0 = 0) or  (i1 = 0)) then 
    return "0";
  else
    return "1";
  end if;
end;

function uBOOL_OR(i0: in integer;
	      i1: in integer) return UNSIGNED is
-- performs ((i0)||(i1))
begin
  if ((i0 = 0) and (i1 = 0)) then
    return "0";
  else
    return "1";
  end if;
end;

function uBOOL_NOT(i0: in integer) return UNSIGNED is
-- performs (!(i0))
begin
  if (i0 = 0) then
    return "1";
  else
    return "0";
  end if;
end;

function uBOOL_NOT(i0: in integer) return integer is
-- performs (!(i0))
begin
  if (i0 = 0) then
    return 1;
  else
    return 0;
  end if;
end;

function uBOOL_NAND(i0: in integer;
	      i1: in integer) return UNSIGNED is
-- performs (!((i0)&&(i1)))
begin
  if (uBOOL_AND(i0, i1) = "1") then
    return "0";
  else 
    return "1";
  end if;
end;

function uBOOL_NOR(i0: in integer;
	      i1: in integer) return UNSIGNED is
-- performs (!((i0)||(i1)))
begin
  if (uBOOL_OR(i0, i1) = "1") then
    return "0";
  else
    return "1";
  end if;
end;

function uBOOL_XOR(i0: in integer;
	      i1: in integer) return UNSIGNED is
-- performs ((i0)xor(i1))
begin
  if ((i0 = 0) and (i1 = 0)) then
    return "0";
  elsif ((i0 = 0) or (i1 = 0)) then
    return "1";
  else
    return "0";
  end if;
end;

function uBOOL_XNOR(i0: in integer;
	      i1: in integer) return UNSIGNED is
-- performs (!((i0)xor(i1)))
begin
  if (uBOOL_XOR(i0, i1) = "1") then 
    return "0";
  else
    return "1";
  end if;
end;

-- /* Logical AND, OR, NOT, NAND, NOR, XOR, XNOR */
function uBOOL_AND(i0: in UNSIGNED;
	      i1: in integer) return UNSIGNED is
-- performs ((i0)&&(i1))
begin
  if ((i0 = "0") or  (i1 = 0)) then 
    return "0";
  else
    return "1";
  end if;
end;

function uBOOL_AND(i0: in integer;
	      i1: in UNSIGNED) return UNSIGNED is
-- performs ((i0)&&(i1))
begin
  return uBOOL_AND(i1, i0);
end;

function uBOOL_OR(i0: in UNSIGNED;
	      i1: in integer) return UNSIGNED is
-- performs ((i0)||(i1))
begin
  if ((i0 = "0") and (i1 = 0)) then
    return "0";
  else
    return "1";
  end if;
end;

function uBOOL_OR(i0: in integer;
	      i1: in UNSIGNED) return UNSIGNED is
-- performs ((i0)||(i1))
begin
  return uBOOL_OR(i1, i0);
end;


function uBOOL_NAND(i0: in UNSIGNED;
	      i1: in integer) return UNSIGNED is
-- performs (!((i0)&&(i1)))
begin
  if (uBOOL_AND(i0, i1) = "1") then
    return "0";
  else 
    return "1";
  end if;
end;

function uBOOL_NAND(i0: in integer;
	      i1: in UNSIGNED) return UNSIGNED is
-- performs (!((i0)&&(i1)))
begin
  return uBOOL_NAND(i1, i0);
end;

function uBOOL_NOR(i0: in UNSIGNED;
	      i1: in integer) return UNSIGNED is
-- performs (!((i0)||(i1)))
begin
  if (uBOOL_OR(i0, i1) = "1") then
    return "0";
  else
    return "1";
  end if;
end;

function uBOOL_NOR(i0: in integer;
	      i1: in UNSIGNED) return UNSIGNED is
-- performs (!((i0)||(i1)))
begin
  return uBOOL_NOR(i1, i0);
end;

function uBOOL_XOR(i0: in UNSIGNED;
	      i1: in integer) return UNSIGNED is
-- performs ((i0)xor(i1))
begin
  if ((i0 = "0") and (i1 = 0)) then
    return "0";
  elsif ((i0 = "0") or (i1 = 0)) then
    return "1";
  else
    return "0";
  end if;
end;

function uBOOL_XOR(i0: in integer;
	      i1: in UNSIGNED) return UNSIGNED is
-- performs ((i0)xor(i1))
begin
  return uBOOL_XOR(i1, i0);
end;

function uBOOL_XNOR(i0: in UNSIGNED;
	      i1: in integer) return UNSIGNED is
-- performs (!((i0)xor(i1)))
begin
  if (uBOOL_XOR(i0, i1) = "1") then 
    return "0";
  else
    return "1";
  end if;
end;

function uBOOL_XNOR(i0: in integer;
	      i1: in UNSIGNED) return UNSIGNED is
-- performs (!((i0)xor(i1)))
begin
  return uBOOL_XOR(i1, i0);
end;

-- /* Bitwise AND, OR, NOT, NAND, NOR, XOR, XNOR :operate on unsigned's */
function uAND(i0: in unsigned;
	      i1: in unsigned) return unsigned is
-- performs ((i0)&(i1))
begin
	return i0 and i1;
end;

function uOR(i0: in unsigned;
	      i1: in unsigned) return unsigned is
-- performs ((i0)|(i1))
begin
	return i0 or i1;
end;

function uNOT(i0: in unsigned) return unsigned is
-- performs (~(i0))
begin
	return not(i0);
end;

function uNAND(i0: in unsigned;
	      i1: in unsigned) return unsigned is
-- performs (~((i0)&(i1)))
begin
	return not (i0 and i1);
end;

function uNOR(i0: in unsigned;
	      i1: in unsigned) return unsigned is
-- performs (~((i0)|(i1)))
begin
	return i0 nor i1;
end;

function uXOR(i0: in unsigned;
	      i1: in unsigned) return unsigned is
-- performs ((i0)^(i1))
begin
	return i0 xor i1;
end;

function uXNOR(i0: in unsigned;
	      i1: in unsigned) return unsigned is
-- performs (~((i0)^(i1)))
begin
	return not(i0 xor i1);
end;

function uLSH(i0: in unsigned;
	       i1: in integer) return unsigned is
-- performs ((i0)<<(i1))
begin
	return shift_LEFT(i0, i1);
end;

function uLSH(i0: in integer;
	       i1: in integer) return integer is
-- performs ((i0)<<(i1))
begin
	if (i0 < 0) then 
		return TO_INTEGER(shift_LEFT(TO_SIGNED(i0,32), i1));
	else
		return TO_INTEGER(shift_LEFT(TO_UNSIGNED(i0,32), i1));
	end if;
end;

function uLSH1(i0: in unsigned) return unsigned is
-- performs ((i0)<<1)
begin
	return shift_LEFT(i0, 1);
end;

function uLSH1(i0: in integer) return integer is
-- performs ((i0)<<1)
begin
	if (i0 < 0) then
		return TO_INTEGER(shift_LEFT(TO_SIGNED(i0,32), 1));
	else
		return TO_INTEGER(shift_LEFT(TO_UNSIGNED(i0,32), 1));
	end if;
end;
      
function uRSH(i0: in unsigned;
	       i1: in integer) return unsigned is
-- performs ((i0)>>(i1))
begin
	return shift_RIGHT(i0, i1);
end;

function uRSH(i0: in integer;
	       i1: in integer) return integer is
-- performs ((i0)>>(i1))
begin
	if (i0 < 0) then
		return TO_INTEGER(shift_RIGHT(TO_SIGNED(i0,32), i1));
	else
		return TO_INTEGER(shift_RIGHT(TO_UNSIGNED(i0,32), i1));
	end if;
end;

function uRSH1(i0: in unsigned) return unsigned is
-- performs ((i0)>>1)
begin
	return shift_RIGHT(i0, 1);
end;

function uRSH1(i0: in integer) return integer is
-- performs ((i0)>>1)
begin
	if (i0 < 0) then
		return TO_INTEGER(shift_RIGHT(TO_SIGNED(i0,32), 1));
	else
		return TO_INTEGER(shift_RIGHT(TO_UNSIGNED(i0,32), 1));
	end if;
end;
      
function uRSH8(i0: in unsigned) return unsigned is
-- performs ((i0)>>8)
begin
	return shift_RIGHT(i0, 8);
end;

function uRSH8(i0: in integer) return integer is
-- performs ((i0)>>8)
begin
	if (i0 < 0) then
		return TO_INTEGER(shift_RIGHT(TO_SIGNED(i0,32), 8));
	else
		return TO_INTEGER(shift_RIGHT(TO_UNSIGNED(i0,32), 8));
	end if;
end;

function uCPL2(i0: in signed) return signed is
-- performs ((~(i0))+1) (computes 2's Complement)
begin
	return not(i0)+1;
end;

function uU_MINUS(i0: in integer) return integer is
-- performs (-(i0))
begin
	return -i0;
end;

function uTIMES(i0: in integer;
	       i1: in integer) return integer is
-- performs ((i0)*(i1))
begin
	return i0 * i1;
end;

function uDIVIDE(i0: in integer;
	          i1: in integer) return integer is
-- performs ((i0)/(i1))
begin
	return i0 / i1;
end;

--/*machine dependent if negative*/
function uMOD(i0: in integer;
	       i1: in integer) return integer is
-- performs ((i0)%(i1))
begin
	return i0 mod i1;
end;


--/* old stuff to be compatible */
function uMINUS(i0: in integer;
	         i1: in integer) return integer is
-- performs ((i0)-(i1))
begin
	return i0 - i1;
end;

function uMUL(i0: in integer;
	       i1: in integer) return integer is
-- performs ((i0)*(i1))
begin
	return i0 * i1;
end;

function uTIME(i0: in integer;
	       i1: in integer) return integer is
-- performs ((i0)*(i1))
begin
	return i0 * i1;
end;


--/* 
--******************************************************************* 
--END VHDL routine LIBRARY FOR uC *********************************** 
--******************************************************************* 
--*/
end uC_routines_synth_pkg;
