#!perl
#
# Author: Bassam Tabbara, UC Berkeley (tbassam@eecs.berkeley.edu)
# SHIFT modifier
#
# Usage: s2s <SHIFT file> 
# Output: file.shift (SHIFT file with no line breaks)
#

#get filename
$filename = sprintf "%s", $ARGV[0];
@names = split(/\./,$filename);
$name = $names[0];

#global variable declarations
$linecount = 0;

#subroutines

#output files
$outputfilename = sprintf ">./%s.vshift", $name;
open(OUT, $outputfilename) || die 
    "Can't open file $outputfilename: $!\n";

#parse SHIFT file
parse:
while(<>) {

    $_ =~ s/_[\$\*]_//g; # remove "_$_" and "_*_" of interfaces to make legal names

    $_ =~ s/\%.*//g; # remove all attributes

    $_ =~ s/\|(\S)/\| $1/g; # replace "|..." separator by "| ..."

    if (/^(.*)\\\n/) {
	++$linecount;
	#print $_;
	print OUT $1; # delete \ and newline (\n)
    }
    else {
	print OUT $_;
    }
    
}

#printf "\n\n\n Replaced: %d", $linecount;

#done
close(OUT);


