#!perl
#
# Author: Bassam Tabbara, UC Berkeley (tbassam@eecs.berkeley.edu)
# VHDL modifier
#
# Usage: v2v <VHDL file> 
# Output: file.vhd (VHDL file with no "__...." (underscore) sequence)
#

#get filename
$filename = sprintf "%s", $ARGV[0];
@names = split(/\./,$filename);
$name = $names[0];

#global variable declarations
$linecount = 0;

#subroutines

#output files
$outputfilename = sprintf ">./%s.vhdl", $name;
open(OUT, $outputfilename) || die 
    "Can't open file $outputfilename: $!\n";

#parse SHIFT file
parse:
while(<>) {
    
    $buf = $_;
    $buf =~ s/_[_]+/_u/g;
    $buf =~ s/ [_]+/ u/g;
    #if ($buf ne $_) {
	#print "original: ", $_;
	#print "changed: ", $buf;
    #}
    print OUT $buf;
}

#done
close(OUT);


