/*************************************************************************

  Copyright   [Copyright (c) 1994-1996 The Regents of the Univ. of California.
  All rights reserved.

  Permission is hereby granted, without written agreement and without license
  or royalty fees, to use, copy, modify, and distribute this software and its
  documentation for any purpose, provided that the above copyright notice and
  the following two paragraphs appear in all copies of this software.

  IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY FOR
  DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
  OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF THE UNIVERSITY OF
  CALIFORNIA HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

  THE UNIVERSITY OF CALIFORNIA SPECIFICALLY DISCLAIMS ANY WARRANTIES,
  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
  FITNESS FOR A PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS ON AN
  "AS IS" BASIS, AND THE UNIVERSITY OF CALIFORNIA HAS NO OBLIGATION TO PROVIDE
  MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.]

******************************************************************************/
/* 68HC11E9 */
#define __IT_type __mod2__ void

/* positions in the interrupt _VECTOR of the various ISRs */
#define IC1_VEC 12
#define IC2_VEC 11
#define IC3_VEC 10
/* IC4 is same as OC5 */
#define IC4_VEC 5

#define OC1_VEC 9
#define OC2_VEC 8
#define OC3_VEC 7
#define OC4_VEC 6
/* IC4 is same as OC5 */
#define OC5_VEC 5

typedef union {
   struct {
      unsigned char b0:1;
         unsigned char b1:1;
         unsigned char b2:1;
         unsigned char b3:1;
         unsigned char b4:1;
         unsigned char b5:1;
         unsigned char b6:1;
         unsigned char b7:1;
   } bit;
   unsigned char byte;
} REG_U8;

/*typedef unsigned char REG_U8;*/
typedef unsigned short REG_U16;
 

/* i registri sono a un indirizzo fisso nella sezione H11REGS che viene 
lincata all'indirizzo giusto nel file di comandi del linker */

/* L'inserimento di questa variabile fittizia mi serve per bypassare l'inserimento
dal parte del compilatore, della direttiva "section .bss,bss" prima di 
"fittizia". Poi frego il compilatore mettendo la nuova section H11REGS */

REG_U8	fittizia;

asm("\t section .H11REGS");

REG_U8	_r_h11porta;	/*	i/o port A	*/
REG_U8  _r_reserved0;	/*	reserved	*/
REG_U8	_r_h11pioc;	/*	parallel i/o control register	*/
REG_U8	_r_h11portc;	/*	i/o port C	*/
REG_U8	_r_h11portb;	/*	i/o port B	*/
REG_U8	_r_h11portcl;	/*	alternate latched port C	*/
REG_U8	_r_reserved1;	/*	reserved	*/
REG_U8	_r_h11ddrc;	/*	data direction for port C	*/
REG_U8	_r_h11portd;	/*	i/o port D	*/
REG_U8	_r_h11ddrd;	/*	i/o data direction for port D	*/
REG_U8	_r_h11porte;	/*	input port E	*/
REG_U8	_r_h11cforc;	/*	compare force register	*/
REG_U8	_r_h11oc1m;	/*	OC1 action mask register	*/
REG_U8	_r_h11oc1d;	/*	OC1 action data register	*/
REG_U16 _r_h11tcnt;	/*	timer counter register	*/
REG_U16 _r_h11tic1;	/*	input capture register 1	*/
REG_U16 _r_h11tic2;	/*	input capture register 2	*/
REG_U16 _r_h11tic3;	/*	input capture register 3	*/
REG_U16 _r_h11toc1;	/*	output compare register 1	*/
REG_U16 _r_h11toc2;	/*	output compare register 2	*/
REG_U16 _r_h11toc3;	/*	output compare register 3	*/
REG_U16 _r_h11toc4;	/*	output compare register 4	*/
REG_U16 _r_h11toc5;	/*	output compare register 5	*/
REG_U8	_r_h11tctl1;	/*	timer control register 1	*/
REG_U8	_r_h11tctl2;	/*	timer control register 2	*/
REG_U8	_r_h11tmsk1;	/*	main timer interrupt mask 1	*/
REG_U8	_r_h11tflg1;	/*	main timer interrupt flag 1	*/
REG_U8	_r_h11tmsk2;	/*	misc timer interrupt mask 2	*/
REG_U8	_r_h11tflg2;	/*	misc timer interrupt flag 2	*/
REG_U8	_r_h11pactl;	/*	pulse accumulator control register	*/
REG_U8	_r_h11pacnt;	/*	pulse accumulator count register	*/
REG_U8	_r_h11spcr;	/*	SPI control register	*/
REG_U8	_r_h11spsr;	/*	SPI status register	*/
REG_U8	_r_h11spdr;	/*	SPI data in/out	*/
REG_U8	_r_h11baud;	/*	SCI baud rate control	*/
REG_U8	_r_h11sccr1;	/*	SCI control register 1	*/
REG_U8	_r_h11sccr2;	/*	SCI control register 2	*/
REG_U8	_r_h11scsr;	/*	SCI status register	*/
REG_U8	_r_h11scdr;	/*	SCI data	*/
REG_U8	_r_h11adctl;	/*	A to D control register	*/
REG_U8	_r_h11adr1;	/*	A to D result 1	*/
REG_U8	_r_h11adr2;	/*	A to D result 2	*/
REG_U8	_r_h11adr3;	/*	A to D result 3	*/
REG_U8	_r_h11adr4;	/*	A to D result 4	*/
REG_U8	_r_h11bprot;	/*	EEPROM block protect register	*/
REG_U8	_r_reserved2;	/*	reserved	*/
REG_U8	_r_reserved3;	/*	reserved	*/
REG_U8	_r_reserved4;	/*	reserved	*/
REG_U8	_r_h11option;	/*	system configuration options	*/
REG_U8	_r_h11coprst;	/*	arm/reset COP timer circutry	*/
REG_U8	_r_h11pprog;	/*	EEPROM programming control	*/
REG_U8	_r_h11hprio;	/*	highest priority I-bit and misc.	*/
REG_U8	_r_h11init;	/*	ram/io mapping register	*/
REG_U8	_r_h11test1;	/*	factory test control register	*/
REG_U8	_r_h11config;	/*	COP, ROM, & EEPROM enables	*/

init_hw()
{

#ifdef	EMULATOR
extern void _VECTOR(void (* func)(void), int _VECTOR);
_VECTOR(int_sci, 0);
_VECTOR(int_spi, 1);
_VECTOR(int_paif, 2);
_VECTOR(int_paovf, 3);
_VECTOR(int_of, 4);
_VECTOR(int_oc5, 5);
_VECTOR(int_oc4, 6);
_VECTOR(int_oc3, 7);
_VECTOR(int_oc2, 8);
_VECTOR(int_oc1, 9);
_VECTOR(int_ic3, 10);
_VECTOR(int_ic2, 11);
_VECTOR(int_ic1, 12);
_VECTOR(int_rti, 13);
_VECTOR(int_irq, 14);
_VECTOR(int_xirq, 15);
_VECTOR(int_illopcode, 17);
_VECTOR(int_cop, 18);
_VECTOR(int_clock, 19);
#endif

/* 0=input  1=output */

_r_h11pactl.bit.b7  = 0;
_r_h11ddrc.byte     = 0;	
_r_h11ddrd.byte     = 0;


/***
enable_interrupt
***/

}
