/*
 *
 * 	vers= 1.0
 *
 *	ETU.ld - command file for C for 68HC11KG4
 *
 *
 */

set H11RAM = 0x00;		/* page containing 68HC11 base page */
set H11REG = 0x01;		/* page containing 68HC11 registers */
set ROM1ORG = 0xA013;		/* origin of 68HC11KG4 rom1 */
set ROM2ORG = 0xC000;		/* origin of 68HC11KG4 rom2 */
set REGORG  = 0x1000;		/* origin of 68HC11KG4 register */
set H11EEP  = 0x0D80;		/* origin of 68HC11GAUSS eeprom	*/

set ROM1SIZE  = 0X1E40;           /* size of 68HC11GAUSS rom */
set ROM2SIZE  = 0X3FC0;           /* size of 68HC11GAUSS rom */
set RAMSIZE   = 768;              /* size of 68HC11GAUSS ram */
set H11RAMREG = (H11RAM<<4)|H11REG; /* mask for setting H11INIT in start.s */
set H11REGORG = (H11REG<<12)		/* origin of 68HC11 registers */

set TSTVECORG = 0xBFCC;		/* origin of 68HC11KG4 test vectors */ 
set STDVECORG = 0xFFCC;		/* origin of 68HC11KG4 int vectors */ 
set VECSIZE   = 52;		/* size of 68HC11GAUSS vectors */
set DELIBSIZE = 0x0013;		/* size of 68HC11GAUSS vectors */

section .bss bss origin 0x100 maxsize RAMSIZE; 

section .H11REGS bss origin H11REGORG;
section .VARDEB  bss  origin 0x200;   /* emulator memory ! */
section .base bss origin 0 maxsize 0x100;
section .H11E2 bss origin H11EEP;

check endof(.bss) >= 0x300 fatal "RAM area too large";

section .text1 text origin 0xA000 maxsize ROM1SIZE = .text .const .data;
section .H11VEC data origin TSTVECORG maxsize VECSIZE;
/* section .H11VEC data origin STDVECORG maxsize VECSIZE; */
section .text2 text origin ROM2ORG maxsize ROM2SIZE = .text .const .data;

-b 'system_setup.o11' /* start up routine     */

/*
check endof(.rom2) >= 0xffc0 fatal "Code area rom2 too large";
*/
readline;

/*-lcio*/
/* -lc				don't use the C library			*/
-lgen				/* general library			*/
