/*************************************************************************

  Copyright   [Copyright (c) 1994-1996 The Regents of the Univ. of California.
  All rights reserved.

  Permission is hereby granted, without written agreement and without license
  or royalty fees, to use, copy, modify, and distribute this software and its
  documentation for any purpose, provided that the above copyright notice and
  the following two paragraphs appear in all copies of this software.

  IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY FOR
  DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
  OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF THE UNIVERSITY OF
  CALIFORNIA HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

  THE UNIVERSITY OF CALIFORNIA SPECIFICALLY DISCLAIMS ANY WARRANTIES,
  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
  FITNESS FOR A PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS ON AN
  "AS IS" BASIS, AND THE UNIVERSITY OF CALIFORNIA HAS NO OBLIGATION TO PROVIDE
  MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.]

******************************************************************************/
/* 68HC11gauss */
#define __IT_type __mod2__ void

#define IC1_VEC 17
#define IC2_VEC 16
#define IC3_VEC 15
/* IC4 is same as OC5 */
#define IC4_VEC  10

#define OC1_VEC 14
#define OC2_VEC 13
#define OC3_VEC 12
#define OC4_VEC 11
/* IC4 is same as OC5 */
#define OC5_VEC  10

#define OVF_VEC  7

typedef union {
   struct {
      unsigned char b0:1;
         unsigned char b1:1;
         unsigned char b2:1;
         unsigned char b3:1;
         unsigned char b4:1;
         unsigned char b5:1;
         unsigned char b6:1;
         unsigned char b7:1;
   } bit;
   unsigned char byte;
} REG_U8;

typedef unsigned short REG_U16;
 

/* registers are located in the H11REGS section, that is assigned to the
 * right address by the linker command file
 */

/* dummy is needed to bypass the "section .bss,bss" directive inserted
 * by the compiler
 */

REG_U8	dummy;

asm("\t section .H11REGS");

REG_U8	_r_h11porta;	/*	i/o port A	*/
REG_U8  _r_h11ddra;	/*  data direction for port A */
REG_U8	_r_h11ddrb;	/*	data direction for port B	*/
REG_U8	_r_h11ddrf;	/*	data direction for port F	*/
REG_U8	_r_h11portb;	/*	i/o port B	*/
REG_U8	_r_h11portf;	/*	i/o port F	*/
REG_U8	_r_h11portc;	/*	i/o port C	*/
REG_U8	_r_h11ddrc;	/*	data direction for port C	*/
REG_U8	_r_h11portd;	/*	i/o port D	*/
REG_U8	_r_h11ddrd;	/*	data direction for port D	*/
REG_U8	_r_h11porte;	/*	i/o port E	*/
REG_U8	_r_h11cforc;	/*	compare force register	*/
REG_U8	_r_h11oc1m;	/*	OC1 action mask register	*/
REG_U8	_r_h11oc1d;	/*	OC1 action data register	*/
REG_U16 _r_h11tcnt;	/*	timer counter register	*/
REG_U16 _r_h11tic1;	/*	input capture register 1	*/
REG_U16 _r_h11tic2;	/*	input capture register 2	*/
REG_U16 _r_h11tic3;	/*	input capture register 3	*/
REG_U16 _r_h11toc1;	/*	output compare register 1	*/
REG_U16 _r_h11toc2;	/*	output compare register 2	*/
REG_U16 _r_h11toc3;	/*	output compare register 3	*/
REG_U16 _r_h11toc4;	/*	output compare register 4	*/
REG_U16 _r_h11toc5;	/*	output compare register 5	*/
REG_U8	_r_h11tctl1;	/*	timer control register 1	*/
REG_U8	_r_h11tctl2;	/*	timer control register 2	*/
REG_U8	_r_h11tmsk1;	/*	main timer interrupt mask 1	*/
REG_U8	_r_h11tflg1;	/*	main timer interrupt flag 1	*/
REG_U8	_r_h11tmsk2;	/*	misc timer interrupt mask 2	*/
REG_U8	_r_h11tflg2;	/*	misc timer interrupt flag 2	*/
REG_U8	_r_h11pactl;	/*	pulse accumulator control register	*/
REG_U8	_r_h11pacnt;	/*	pulse accumulator count register	*/
REG_U8	_r_h11spcr;	/*	SPI control register	*/
REG_U8	_r_h11spsr;	/*	SPI status register	*/
REG_U8	_r_h11spdr;	/*	SPI data in/out	*/
REG_U8	_r_h11eprog;	
REG_U8	_r_h11ppar;
REG_U8	_r_reserved1;	/*	reserved	*/
REG_U8	_r_h11pllcr;
REG_U8	_r_h11synr;
REG_U8	_r_h11adctl;	/*	A to D control register	*/
REG_U8	_r_reserved2;	/*	reserved	*/
REG_U8	_r_h11adfrq;
REG_U8	_r_h11rtreg;
REG_U8  _r_h11rtctl;
REG_U8	_r_h11bprot;
REG_U8	_r_reserved3;	/*	reserved	*/
REG_U8	_r_h11init2;
REG_U8	_r_h11opt2;
REG_U8	_r_h11option;
REG_U8	_r_h11coprst;	/*	arm/reset COP timer circutry	*/
REG_U8	_r_h11pprog;	/*	EEPROM programming control	*/
REG_U8	_r_h11hprio;	/*	highest priority I-bit and misc.	*/
REG_U8	_r_h11init;	/*	ram/io mapping register	*/
REG_U8	_r_h11test1;	/*	factory test control register	*/
REG_U8	_r_h11config;	/*	COP, ROM, & EEPROM enables	*/
REG_U16	_r_h11adr1;	
REG_U16	_r_h11adr2;	
REG_U16	_r_h11adr3;	
REG_U16	_r_h11adr4;	
REG_U16	_r_h11adr5;	
REG_U16	_r_h11adr6;	
REG_U16	_r_h11adr7;	
REG_U16	_r_h11adr8;	
REG_U16	_r_h11sc1bd;	
REG_U8 	_r_h11sc1cr1;	
REG_U8 	_r_h11sc1cr2;	
REG_U8 	_r_h11sc1sr1;	
REG_U8 	_r_h11sc1sr2;	
REG_U16	_r_h11sc1dr;	
REG_U8 	_r_h11jkflag;	
REG_U8 	_r_h11jkmask;	
REG_U8 	_r_h11portj;	
REG_U8 	_r_h11ddrj;	
REG_U8 	_r_h11porth;	
REG_U8 	_r_h11pthms;	
REG_U8 	_r_h11portk;	
REG_U8 	_r_h11ptkms;	

REG_U16 _r_h11pwdty0;	/*	PWM duty cycle 0	*/
REG_U16 _r_h11pwdty1;	/*	PWM duty cycle 1	*/
REG_U16 _r_h11pwdty2;	/*	PWM duty cycle 2	*/
REG_U16 _r_h11pwdty3;	/*	PWM duty cycle 3	*/
REG_U16 _r_h11pwdty4;	/*	PWM duty cycle 4	*/
REG_U16 _r_h11pwdty5;	/*	PWM duty cycle 5	*/
REG_U16 _r_h11pwdty6;	/*	PWM duty cycle 6	*/
REG_U16 _r_h11pwdty7;	/*	PWM duty cycle 7	*/

REG_U16	_r_h11sc2bd;	
REG_U8 	_r_h11sc2cr1;	
REG_U8 	_r_h11sc2cr2;	
REG_U8 	_r_h11sc2sr1;	
REG_U8 	_r_h11sc2sr2;	
REG_U16	_r_h11sc2dr;	

REG_U8	_r_h11pwck;		/*	PWM counter	clock control register */
REG_U8	_r_h11pwen;		/*	PWM channel enable */
REG_U8	_r_h11pwpol;		/*	PWM channel enable */
REG_U16	_r_h11pwcnt;	/*	PWM counter	*/

REG_U8	_r_h11dacon;
REG_U8	_r_h11da1;


__IT_type dummy_int ()
{ /* empty */
}



init_hw()
{
#ifdef EMULATOR
int main (); 
void _VECTOR(void (* func)(void), int vector);

_VECTOR(dummy_int, 0 );
_VECTOR(dummy_int, 1 );
_VECTOR(dummy_int, 2 );
_VECTOR(dummy_int, 3 );
_VECTOR(dummy_int, 4 );
_VECTOR(dummy_int, 5 );
_VECTOR(dummy_int, 6 );
_VECTOR(dummy_int, 7 );
_VECTOR(dummy_int, 8 );
_VECTOR(dummy_int, 9 );
_VECTOR(dummy_int, 10 );
_VECTOR(dummy_int, 11 );
_VECTOR(dummy_int, 12 );
_VECTOR(dummy_int, 13 );
_VECTOR(dummy_int, 14 );
_VECTOR(dummy_int, 15 );
_VECTOR(dummy_int, 16 );
_VECTOR(dummy_int, 17 );
_VECTOR(dummy_int, 18 );
_VECTOR(dummy_int, 19 );
_VECTOR(dummy_int, 20 );
_VECTOR(dummy_int, 21 );
/* re-initialize everything */
_VECTOR(main, 22 );
_VECTOR(main, 23 );
_VECTOR(main, 24 );
_VECTOR(main, 25 ); 
#endif
/* 0=input  1=output */

_r_h11pactl.bit.b7  = 0;
_r_h11ddrc.byte     = 0;	
_r_h11ddrd.byte     = 0;


/***
enable_interrupt
***/

}
