/*                                                              
************************************************************** 
BEGIN COMMON PART ********************************************
************************************************************** 
*/                                                             
#ifndef MAIN
#ifndef DOING_TASK
#define MAIN
#endif
#endif

#ifndef ARGS
#ifdef __STDC__
#define ARGS(args) args
#define NULLARGS   ()
#else
#define NULLARGS   ()
#define ARGS(args) ()
#endif /*__STDC__*/
#endif /* ARGS */

#ifdef UNIX
#define const
#endif /*UNIX*/

#ifdef UNIX
#ifdef extern
#undef extern
#endif /*extern*/
#define _O_PORT_INIT(e) {}

typedef short event_t;
typedef struct { short e; long int v; } event_value_t;
typedef long int value_t;
#else /*UNIX*/
#define _O_PORT_INIT(e) {}
#endif /*UNIX*/

#define _O_PORT_UP(event) { \
    _O_PORT_INIT(event); \
    *event_o_port[event] = event_o_bit[event]; \
}

#define _O_PORT_DOWN(event) { \
    _O_PORT_INIT(event); \
    *event_o_port[event] = 0; \
}


#ifdef MAIN
#ifdef UNIX
#include <stdio.h>
#include <string.h>
#endif /*UNIX*/

#define extern
#endif /*MAIN*/

#ifdef MAIN
/* parsing and printing routines for floating point types */
#include "uC_types.c"
#endif /*MAIN*/

#ifdef DO_DELAY
#define DELAY(n) _delay += (n)
int _delay;
int cpu;
#else /*DO_DELAY*/
#define DELAY(n)
#endif /*DO_DELAY*/

/* general definitions */                                      

typedef void (*f_task_p_t) ARGS((int, int)); /* pointer to task function */
typedef void (*f_emit_p_t) NULLARGS; /* pointer to emit function */           
typedef void (*f_intr_p_t) NULLARGS; /* pointer to ISR function */     



/*** general macros *****/                                            

/* delimiters of atomic operations */
#define  ATOMIC
#define  END_ATOMIC


/* is processor ready? */
#define  set_ready(p)   (proc_ready[p]=1)
#define  reset_ready(p) (proc_ready[p]=0)
#define  is_ready(p)    (proc_ready[p])



/* general procedures */                                        

/* returns != 0 if event is found in io_port */                
int got_inp_event ARGS((int));                                        

extern void clear_ackn_event ARGS((int)); 

#ifdef ESTEREL
extern int test_inp_event ARGS((int));
#endif /*ESTEREL*/

extern void clear_frozen_inputs ARGS((int));
extern void add_frozen_inputs ARGS((int));
extern void startup ARGS((int));
extern void cleanup ARGS((int, int));
extern void always_cleanup ARGS((int));
extern void _pd_parallel_port ARGS((int));

/* simulation support */

#ifdef UNIX

extern int _show_cfsms 
#ifdef MAIN
= 0
#endif /* MAIN */
;

extern int _show_os 
#ifdef MAIN
= 0
#endif /* MAIN */
;

extern int _show_internals 
#ifdef MAIN
= 0
#endif /* MAIN */
;

extern int _show_values 
#ifdef MAIN
= 0
#endif /* MAIN */
;

extern int _show_inputs 
#ifdef MAIN
= 0
#endif /* MAIN */
;

extern int debug_emit         ARGS((int, int));
extern int debug_print_values NULLARGS;

#define debug_os() if(_show_os) printf("\nEXECUTING OS-->\n");

#define task_exec(proc) \
  if(_show_cfsms) printf("\nSTARTING TASK \t%s:\n",debug_proc_name[proc]); \
  _begin_task(proc); \
  (*task_ptr[proc])(proc, task_inst[proc]); \
  _end_task(proc); \
  if(_show_cfsms) printf("DONE TASK \t%s\n",debug_proc_name[proc]); 




#else /* UNIX */

#define debug_emit(event,is_output)
#define debug_print_values()
#define debug_os()

#define task_exec(proc) (*task_ptr[proc])(proc, task_inst[proc]);

#endif /* UNIX */

/*                                                             
************************************************************** 
END COMMON PART **********************************************
************************************************************** 
*/
