
/*
*******************************************************************
BEGIN MAIN INIT PART **********************************************
*******************************************************************
*/

#ifdef MAIN
#ifdef UNIX
#ifdef extern
#undef extern
#endif /*extern*/

char present_event[N_EVENTS];

init_hw NULLARGS {}
#endif /*UNIX*/

/*
*******************************************************************
*/

#ifdef __STDC__
void
clear_ackn_event(int event)
#else
void 
clear_ackn_event(event) 
int event;
#endif /*__STDC__*/
{


#ifdef UNIX
      *event_iv_port[event]  = ~event_iv_bit[event]  & *event_iv_port[event];
#else /*UNIX*/
      *event_ack_port[event] =  event_ack_bit[event];
      *event_ack_port[event] =  0;
#endif /*UNIX*/
}

#ifdef __STDC__
int got_inp_event(int event)
#else
int got_inp_event(event)
int event;
#endif /*__STDC__*/
{ 
  if (event_iv_bit[event] & *event_iv_port[event]) {
    clear_ackn_event(event);
    return 1;
  }
  else {
    return 0;
  }
}


#if defined(UNIX) && defined(DO_DELAY)  
/* monitor routines */
int event_monitor[N_EVENTS];
int check_event[N_EVENTS];
int event_cnt[N_EVENTS];
int event_cnt_1_to_2[N_EVENTS][N_EVENTS];
int event_time_1[N_EVENTS][N_EVENTS];
int event_time_1_to_2[N_EVENTS][N_EVENTS];

int task_beg_time[N_PROCS];
int task_time[N_PROCS];
int task_cnt[N_PROCS];
int min_task_time[N_PROCS], max_task_time[N_PROCS];


#ifdef __STDC__
void
_begin_task (int pid)
#else
void
_begin_task (pid)
int pid;
#endif /*__STDC__*/
{
	task_beg_time[pid] = _delay;	
}

#ifdef __STDC__
void
_end_task (int pid)
#else
void
_end_task (pid)
int pid;
#endif /*__STDC__*/
{
    int time;
    time = _delay - task_beg_time[pid];
    task_time[pid] += time;
    if (! min_task_time[pid] || time < min_task_time[pid]) 
         min_task_time[pid] = time;
    if (! max_task_time[pid] || time > max_task_time[pid]) 
         max_task_time[pid] = time;
	task_cnt[pid]++;
}

#ifdef __STDC__
void
get_monitor_events (void)
#else
void
get_monitor_events ()
#endif /*__STDC__*/
{
   int ee, cnt, cc;
   char ss[256], ssline[1024], *sslinep;

      printf("\n\nevents to be monitored> ");
      sslinep = ssline;
	  cnt = 0;
      while ((cc = (fgetc(stdin))) != ';') {
         if (cc == EOF) {
            exit (0);
         }
         *sslinep = cc;
         sslinep++;
      }
      *sslinep = '\0';

      sslinep = ssline;
      while (sscanf(sslinep, "%s", ss) != EOF) {
         sslinep = sslinep + strlen(ss) + 1;
		 ee = find_event(ss, /*silent*/ 1);
		 if (ee != -1) {
			check_event[ee] = 1;
			event_monitor[cnt++] = ee;
		 }
	  }
	  event_monitor[cnt++] = -1;
}

#ifdef __STDC__
void
_monitor_event (int event)
#else 
void
_monitor_event (event)
int event;
#endif /*__STDC__*/
{
  int i;

  event_cnt[event]++;
  for (i = 0; event_monitor[i] >= 0; i++) {
	/* here event is source */
	event_time_1[event][event_monitor[i]] = _delay;
	/* here event is target */
	if (event_time_1[event_monitor[i]][event]) {
		event_time_1_to_2[event_monitor[i]][event] += 
			_delay - event_time_1[event_monitor[i]][event];
		event_cnt_1_to_2[event_monitor[i]][event]++;
		event_time_1[event_monitor[i]][event] = 0;
	}
  }
}

int
_print_monitor NULLARGS
{
	int p, e1, e2;
	fprintf (stderr, "Task information\n");
	for (p = 0; p < N_PROCS; p++) {
		if (! task_cnt[p]) {
			continue;
		}
        fprintf (stderr, "%s invoc. %d min %d max %d avg %d cyc\n",
            debug_proc_name[p], task_cnt[p], min_task_time[p],
            max_task_time[p], task_time[p] / task_cnt[p]);
	}
	fprintf (stderr, "Event information\n");
	for (e1 = 0; e1 < N_EVENTS; e1++) {
		if (! event_cnt[e1]) {
			continue;
		}
		fprintf (stderr, "%s: occ. %d avg. cyc to: ", 
			debug_event_name[e1], event_cnt[e1]);
		for (e2 = 0; e2 < N_EVENTS; e2++) {
			if (e1 == e2 || ! event_cnt[e2] || ! event_cnt_1_to_2[e1][e2]) {
				continue;
			}
			/* skip if obviously unrelated */
			/* if (event_cnt[e2] / event_cnt[e1] > 3 ||
			 *	event_cnt[e1] / event_cnt[e2] > 3) {
			 *	continue;
			 * }
			 */
			fprintf (stderr, "%s (%d/%d) %d ",
			debug_event_name[e2], event_cnt_1_to_2[e1][e2], event_cnt[e2],
			event_time_1_to_2[e1][e2] / event_cnt_1_to_2[e1][e2]);
		}
		fprintf (stderr, "\n");
	}
}
#else  /* UNIX && DO_DELAY */

#define _begin_task(pid)
#define _end_task(pid)
#define get_monitor_events()
#define _moinitor_event(event)
#define _print_monitor()

#endif /* UNIX && DO_DELAY */
/* outbound events p-drivers */

#ifdef __STDC__
void 
_pd_parallel_port(int event) 
#else
void 
_pd_parallel_port(event) 
int event;
#endif /*__STDC__*/
{
  _O_PORT_UP(event);
  _O_PORT_DOWN(event);
#ifdef UNIX  
#ifdef DO_DELAY
  if (check_event[event]) {
	  _monitor_event (event);
  }
#endif /*DO_DELAY*/
  present_event[event] = 1;
#endif /*UNIX*/
}



/* initialize process array and periph. array */


/* simulation support */
#ifdef UNIX
#ifdef __STDC__
int 
find_event(char *ss, int silent)
#else
int 
find_event(ss, silent)
char *ss;
int silent;
#endif /*__STDC__*/
{
  int i;
  char *nn;

  for (i=0; i<N_EVENTS; i++) {
     nn = debug_event_name[i];
     if (strcmp(ss, nn) == 0) {
        return i;
     }
  }
  if (!silent) {
	  printf ("unknown event %s\n", ss);
  }
  return -1;
}

#ifdef __STDC__
int
debug_emit(int event, int is_output)
#else
int
debug_emit(event, is_output)
int event, is_output;
#endif /*__STDC__*/
{
  char *name;
  if(_show_cfsms || _show_os) printf("\t");
  if (is_output || _show_internals) {
    if ((name=debug_event_value_name[event]) != (char*)0) {
      printf("%s(%s) ", debug_event_name[event],  get_value(name));
    } else {
      printf("%s ", debug_event_name[event]);
    }
  }
  if(_show_cfsms || _show_os) printf("\n");
}

#endif /*UNIX*/

#ifdef __STDC__
void 
clear_frozen_inputs(int proc)
#else
void 
clear_frozen_inputs(proc)
int proc;
#endif /*__STDC__*/
{
  char *base;
  int  i, size;

  base = frozen_inp_events[proc];
  size = num_input_chars[proc];

  for(i=0; i<size; i++) {
    ATOMIC {
      *(base+i) = (char) 0;
    } END_ATOMIC
  }
}


#ifdef __STDC__
void 
add_frozen_inputs(int proc)
#else
void 
add_frozen_inputs(proc)
int proc;
#endif /*__STDC__*/
{
  char  *live, *frozen;
  int   i, size;

  live   = inp_events[proc];
  frozen = frozen_inp_events[proc];
  size = num_input_chars[proc];

  for(i=0; i<size; i++) {
    ATOMIC {
      *(live+i) |= *(frozen+i);
    } END_ATOMIC
  }
}

#ifdef __STDC__
void
startup(int proc)
#else
void
startup(proc)
int proc;
#endif /*__STDC__*/
{
  char *tmp;

  ATOMIC {
    reset_ready(proc);
    if((tmp = inp_events[proc])==(char*)0) return;
    inp_events[proc] = frozen_inp_events[proc]; 
  } END_ATOMIC

  frozen_inp_events[proc] = tmp;
}


#ifdef __STDC__
void
cleanup(int proc, int has_emitted)
#else
void
cleanup(proc, has_emitted)
int  proc;
int has_emitted;
#endif /*__STDC__*/
{
  if(inp_events[proc]==(char*)0) return;
  if(!has_emitted) add_frozen_inputs(proc);
  clear_frozen_inputs(proc);
}

#ifdef __STDC__
void
always_cleanup(int proc)
#else
void
always_cleanup(proc)
int  proc;
#endif /*__STDC__*/
{
  if(inp_events[proc]==(char*)0) return;
  clear_frozen_inputs(proc);
}



/*
*******************************************************************
END MAIN INIT PART ************************************************
*******************************************************************
*/
