#ifndef _DEpwm_h
#define _DEpwm_h 1
// header file generated from DEpwm.pl by ptlang

#ifdef __GNUG__
#pragma interface
#endif

#include "uC_types.h"
#include "swlib.h"
#include "DETarget.h"
#include "DEPolis.h"
#include "IntState.h"
#include "FloatState.h"
#include "StringState.h"

class DEpwm : public DEPolis
{
public:
	DEpwm();
	/* virtual */ Block* makeNew() const;
	/* virtual*/ const char* className() const;
	/* virtual*/ int isA(const char*) const;
	/* virtual */ void begin();
	InDEPort e_PWMCLK;
	InDEPort e_PWM_DC;
	OutDEPort e_PWM_OUT;
# line 25 "DEpwm.pl"
double now;
    int resourceId;
    double clkFreq;
    /* Input event flags */
    int e_PWMCLK_flag;
    int e_PWM_DC_flag;
    /* Settable constants */
    int c_PWMMAXCOUNT;
    int c_SIMSCALE;
    int c_PWM_POLARITY;
    int c_N;
    /* State and output variables */
    int _st;
    int value;
	int emitEventToIntQ ( int outputPort, double delay );
	void emitEvent (StarLLCell* cell, double emitTime);
	double getDelay ();
	void CleanUp ( int emitted );

protected:
	/* virtual */ void setup();
	/* virtual */ void go();
	StringState implem;
	StringState resourceName;
	FloatState Clock_freq;
	StringState policy;
	IntState Priority;
	StringState firename;
	StringState overname;
	IntState PWMMAXCOUNT;
	IntState SIMSCALE;
	IntState PWM_POLARITY;
	IntState N;

private:
# line 41 "DEpwm.pl"
double *_time, totnf;
    double _nextf, _latency;
    FILE *fpfire;
    FILE *fpover;
    /* Variables for behavioural simulation */
    double ckfr;
    int pwmcount;
    int pwmint;
    int datarec;
    int newval;
    int datum;
    int pwmstart;
    int pwmpol;
    int npwmpol;

};
#endif
