static const char file_id[] = "DEPolis.pl";
// .cc file generated from DEPolis.pl by ptlang

#ifdef __GNUG__
#pragma implementation
#endif

#include "DEPolis.h"

const char *star_nm_DEPolis = "DEPolis";

const char* DEPolis :: className() const {return star_nm_DEPolis;}

ISA_FUNC(DEPolis,DERCStar);

Block* DEPolis :: makeNew() const { LOG_NEW; return new DEPolis;}

# line 52 "DEPolis.pl"
#ifdef BUFSIZE
    #undef BUFSIZE
    #endif
    #define BUFSIZE 1024

    #ifndef __cplusplus
    #define __cplusplus
    #endif 

    #include "pipefork.h"
    #include <sys/wait.h>
    #include <unistd.h>
    #include "swlib.h"
#ifdef GCC_BASED_SIMUL
    #include "mips-vars.h"
#endif

    int DEPolis::counter;
    int DEPolis::priority_pol;
    int DEPolis::priority_next;
    double DEPolis::next_curr;
    double DEPolis::next_glob;
    int DEPolis::star_ack;
    int DEPolis::star_run;
    FILE * DEPolis::fpoverflow;
    FILE * DEPolis::fpfiring;

    FILE * DEPolis::toCommand;
    FILE * DEPolis::fromCommand;
    FILE * DEPolis::breakname;
    FILE * DEPolis::isslog;
    FILE * DEPolis::fptraces;
    int DEPolis::iss_pid;
    int DEPolis::break_inserted;
    int DEPolis::prev_cycles;
    int DEPolis::ptl_cycles;
    double DEPolis::prev_energy;
    double DEPolis::ptl_energy;
    int DEPolis::delay;
    double DEPolis::energy;
    double DEPolis::MinTime;
    double DEPolis::MaxTime;
    double DEPolis::MinEnergy;
    double DEPolis::MaxEnergy;
    double DEPolis::MinPower;
    double DEPolis::MaxPower;
    int DEPolis::xyplotEnergy_created;
    XYPlot DEPolis::xyplotEnergy;
    int DEPolis::xyplotPower_created;
    XYPlot DEPolis::xyplotPower;
    int DEPolis::num_break_inserted;
    clock_t DEPolis::simCpuTime;
    int DEPolis::cache_initialized;

DEPolis::DEPolis ()
{
	setDescriptor("Common Polis Software Scheduler");


}


void DEPolis::resetAll ()
{
# line 112 "DEPolis.pl"
DEPolis::simCpuTime = clock();

      DEPolis::counter = 0;
      DEPolis::priority_pol = -1;
      DEPolis::priority_next = -1;
      DEPolis::next_curr = 0;
      DEPolis::next_glob = 0;
      DEPolis::star_ack = -1;
      DEPolis::star_run = -1;
}


int DEPolis::getImplem ( char *stimpl )
{
# line 130 "DEPolis.pl"
if ( !strcmp( stimpl, "HW" )) {
        return 0;
      } else if ( !strcmp( stimpl, "SW" )) {
        return 1;
      } else if ( !strcmp( stimpl, "BEHAV" )) {
        return 2;
      } else {
        char stemp[ 1024 ];
        strcpy( stemp, stimpl );
        strcat( stemp, ": not a valid implementation" );
        Error::abortRun( stemp );
      }
      return (-1);
}


FILE * DEPolis::Openoverflow ( char *name )
{
# line 152 "DEPolis.pl"
if ( DEPolis::fpoverflow == NULL ) {
        DEPolis::fpoverflow = fopen( name, "w" );
        if ( DEPolis::fpoverflow ) {
          fprintf( DEPolis::fpoverflow, "Overflow report\n\n" );
          fflush( DEPolis::fpoverflow );
        }
      }
      return( fpoverflow );
}


void DEPolis::Printoverflow ( char *st )
{
# line 169 "DEPolis.pl"
if ( DEPolis::fpoverflow ) {
        fprintf( DEPolis::fpoverflow, st );
        fflush( DEPolis::fpoverflow );
      }
}


FILE * DEPolis::Openfiring ( char *name )
{
# line 182 "DEPolis.pl"
if ( DEPolis::fpfiring == NULL ) {
        DEPolis::fpfiring = fopen( name, "w" );
        if ( DEPolis::fpfiring ) {
          fprintf( DEPolis::fpfiring, "Firing report\n\n" );
          fflush( DEPolis::fpfiring );
        }
      }
      return( fpfiring );
}


void DEPolis::Printfiring ( char *st )
{
# line 199 "DEPolis.pl"
if ( DEPolis::fpfiring ) {
        fprintf( DEPolis::fpfiring, st );
        fflush( DEPolis::fpfiring );
      }
}


void DEPolis::Closeflow ()
{
# line 211 "DEPolis.pl"
if ( DEPolis::fpoverflow ) {
        fclose( DEPolis::fpoverflow );
        DEPolis::fpoverflow = NULL;
      }
      if ( DEPolis::fpfiring ) {
        fclose( DEPolis::fpfiring );
        DEPolis::fpfiring = NULL;
      }
      if ( DEPolis::toCommand ) {
        fclose( DEPolis::toCommand );
        DEPolis::toCommand = NULL;
      }
      if ( DEPolis::fromCommand ) {
        fclose( DEPolis::toCommand );
        DEPolis::toCommand = NULL;
      }
      if ( DEPolis::isslog ) {
        fclose( DEPolis::isslog );
        DEPolis::isslog = NULL;
      }
      if ( DEPolis::fptraces ) {
        fclose( DEPolis::fptraces );
        DEPolis::fptraces = NULL;
      }
}


int DEPolis::getincCounter ()
{
# line 243 "DEPolis.pl"
DEPolis::counter++;
      return( DEPolis::counter - 1 );
}


int DEPolis::readPri ()
{
# line 253 "DEPolis.pl"
return( DEPolis::priority_next );
}


double DEPolis::readNext ()
{
# line 262 "DEPolis.pl"
return( DEPolis::next_curr );
}


int DEPolis::testCPU ( double now, int pri )
{
# line 282 "DEPolis.pl"
return(( now >= DEPolis::next_curr && 
               pri >= DEPolis::priority_next ) ||
               pri > DEPolis::priority_next ||
               ( pri == DEPolis::priority_next && 
               pri > DEPolis::priority_pol ));
}


int DEPolis::canRun ( int star_id )
{
# line 296 "DEPolis.pl"
return( DEPolis::star_ack == star_id );
}


void DEPolis::saveContext ( int *opri, double *onxc, int *osrn, int pri )
{
# line 306 "DEPolis.pl"
*opri = DEPolis::priority_pol;
      *onxc = DEPolis::next_curr;
      *osrn = DEPolis::star_run;
      DEPolis::priority_pol = pri;
      DEPolis::priority_next = pri;
      DEPolis::star_run = DEPolis::star_ack;
}


void DEPolis::setNewDelay ( double delay, int now, double *onxg )
{
# line 321 "DEPolis.pl"
DEPolis::next_curr = now + delay;
      if ( now < DEPolis::next_glob ) {
        DEPolis::next_glob += delay;
      } else {
        DEPolis::next_glob = now + delay;
      }
      *onxg = DEPolis::next_glob;
}


double DEPolis::interrupt ( double oldnextg )
{
# line 337 "DEPolis.pl"
return( DEPolis::next_glob - oldnextg );
}


void DEPolis::restoreContext ( double newnextc, int oldpri, int oldstarrun )
{
# line 347 "DEPolis.pl"
DEPolis::next_curr = newnextc;
      DEPolis::priority_pol = oldpri;
      DEPolis::priority_next = oldpri;
      DEPolis::star_ack = -1;
      if ( oldpri >= 0 ) {
        DEPolis::star_run = oldstarrun;
      }
}


int DEPolis::scheduling ( int star_id, int star_pri, char *sched )
{
# line 363 "DEPolis.pl"
int retval;
      
      retval = 0;
      if ( !strcasecmp( sched, "_OldRoundRobin" )) {

        /* Old Round robin scheduler */
        int dist1, dist2;

        if ( DEPolis::star_ack == -1 ) {
          DEPolis::star_ack = star_id;
          retval = 1;
        } else {
          dist1 = DEPolis::star_ack - DEPolis::star_run;
          if ( DEPolis::star_ack <= DEPolis::star_run ) {
            dist1 = DEPolis::counter + dist1;
          }
          dist2 = star_id - DEPolis::star_run;
          if ( star_id <= DEPolis::star_run ) {
            dist2 = DEPolis::counter + dist2;
          }
          if ( dist2 < dist1 ) {
            DEPolis::star_ack = star_id;
            retval = 1;
          } else {
            retval = 0;
          }
        }

      } else if ( !strcasecmp( sched, "RoundRobin" )) {
        /* Round Robin Scheduler */
        int dist1, dist2;
        
        if ( DEPolis::priority_pol > -1 ) {
          retval = 0;
        } else if ( DEPolis::star_ack == -1 ) {
          DEPolis::star_ack = star_id;
          retval = 1;
        } else {
          dist1 = DEPolis::star_ack - DEPolis::star_run;
          if ( DEPolis::star_ack <= DEPolis::star_run ) {
            dist1 = DEPolis::counter + dist1;
          }
          dist2 = star_id - DEPolis::star_run;
          if ( star_id <= DEPolis::star_run ) {
            dist2 = DEPolis::counter + dist2;
          }
          if ( dist2 < dist1 ) {
            DEPolis::star_ack = star_id;
            retval = 1;
          } else {
            retval = 0;
          }
        }

      } else if ( !strcasecmp( sched, "Priority" )) {
        /* Priority Preemptive Scheduler */
        int dist1, dist2;
        
        if ( DEPolis::star_ack == -1 || star_pri > DEPolis::priority_next ) {
          DEPolis::star_ack = star_id;
          DEPolis::priority_next = star_pri;
          retval = 1;
        } else if ( star_pri < DEPolis::priority_next ) {
          retval = 0;
        } else {
          dist1 = DEPolis::star_ack - DEPolis::star_run;
          if ( DEPolis::star_ack <= DEPolis::star_run ) {
            dist1 = DEPolis::counter + dist1;
          }
          dist2 = star_id - DEPolis::star_run;
          if ( star_id <= DEPolis::star_run ) {
            dist2 = DEPolis::counter + dist2;
          }
          if ( dist2 < dist1 ) {
            DEPolis::star_ack = star_id;
            DEPolis::priority_next = star_pri;
            retval = 1;
          } else {
            retval = 0;
          }
        }

      } else if ( !strcasecmp( sched, "NonPreemptive" )) {
        /* Priority Non Preemptive Scheduler */
        int dist1, dist2;
        
        if ( DEPolis::priority_pol > -1 ) {
          retval = 0;
        } else if (DEPolis::star_ack == -1 || star_pri > DEPolis::priority_next) {
          DEPolis::star_ack = star_id;
          DEPolis::priority_next = star_pri;
          retval = 1;
        } else if ( star_pri < DEPolis::priority_next ) {
          retval = 0;
        } else {
          dist1 = DEPolis::star_ack - DEPolis::star_run;
          if ( DEPolis::star_ack <= DEPolis::star_run ) {
            dist1 = DEPolis::counter + dist1;
          }
          dist2 = star_id - DEPolis::star_run;
          if ( star_id <= DEPolis::star_run ) {
            dist2 = DEPolis::counter + dist2;
          }
          if ( dist2 < dist1 ) {
            DEPolis::star_ack = star_id;
            DEPolis::priority_next = star_pri;
            retval = 1;
          } else {
            retval = 0;
          }
        }
      } else {
        /* Not a valid scheduler */
        char stemp[ 1024 ];
        
        strcpy( stemp, sched );
        strcat( stemp, ": not a valid scheduler" );
        Error::abortRun( stemp );
      }
      return( retval );
}


void DEPolis::resetIss ()
{
# line 495 "DEPolis.pl"
DEPolis::simCpuTime = clock();

      DEPolis::prev_cycles = 0;
      DEPolis::ptl_cycles = 0;
      DEPolis::prev_energy = 0.0;
      DEPolis::ptl_energy = 0.0;
      DEPolis::delay = 0;
      DEPolis::break_inserted = 0;
      fprintf( stderr, "DEPolis::iss_pid= %d\n", DEPolis::iss_pid);
//      if (DEPolis::iss_pid) {
//         kill(DEPolis::iss_pid,9);
//      }
      DEPolis::iss_pid = 0;
}


int DEPolis::Pipefork ( char **argv, FILE **toCommand, FILE **fromCommand, \
                 int *pid, char *execname, char *scpu )
{
# line 519 "DEPolis.pl"
int forkpid, waitpid;
    int topipe[2], frompipe[2];
    char buffer[1024];

#if (defined hpux) || (defined __osf__) || (defined _IBMR2) || defined(__SVR4)
    int status;
#else
    union wait status;
#endif

    /* create the PIPES...
     * fildes[0] for reading from command
     * fildes[1] for writing to command
     */
    (void) pipe(topipe);
    (void) pipe(frompipe);

    if ((forkpid = vfork()) == 0) {
       /* child here, connect the pipes */

       setbuf(stdout,NULL);

       (void) dup2(topipe[0], fileno(stdin));
       (void) dup2(frompipe[1], fileno(stdout));
       (void) dup2(frompipe[1], fileno(stderr));

       (void) close(topipe[0]);
       (void) close(topipe[1]);
       (void) close(frompipe[0]);
       (void) close(frompipe[1]);

       if ( !strcmp(scpu,"Chameleon") ) {
          (void) execlp( "pty", "-v", "chsim", "-z", "stat", "-t", "test",
                         (char *) 0);
       }
       else if ( !strcmp(scpu,"SPARC") ) {
//          (void) execlp( "ptydebug", "-v", "sparcsim", "-t", execname, (char *) 0);
          (void) execlp( "pty", "-v", "sparcsim", "-t", execname, (char *) 0);
       }
       (void) sprintf(buffer, "util_pipefork: can not exec %s", argv[0]);
       perror(buffer);
       (void) _exit(1);
    }

    if (pid) {
       *pid = forkpid;
    }

    waitpid = wait3(&status, WNOHANG, 0);

    /* parent here, use slimey vfork() semantics to get return status */
#ifndef sun
    if (waitpid == forkpid && WIFEXITED(status)) {
        return 0;
    }
#endif
    if ((*toCommand = fdopen(topipe[1], "w")) == NULL) {
        return 0;
    }
    if ((*fromCommand = fdopen(frompipe[0], "r")) == NULL) {
        return 0;
    }
    (void) close(topipe[0]);
    (void) close(frompipe[1]);
    return 1;
}


void DEPolis::initIss ( char *brkname, char *execname, char *scpu, \
                 char *root_dir, int ncpu, int iss_debug )
{
# line 594 "DEPolis.pl"
char stemp[80];
       char model_name[80];
       char brk_name[80];

       if ( !strcmp(scpu,"SPARC") ) {
          if (!DEPolis::break_inserted) {

             if ( iss_debug ) {
                sprintf( stemp, "%s/isslog.txt", root_dir ); 
                DEPolis::isslog = fopen( stemp, "w" );
                setbuf(DEPolis::isslog,NULL);
             }

             // Set "debug information" mode
             StringToIss("d\n", iss_debug);

             // Passing cpu value
             StringToIss("w\n", iss_debug);
             StringToIss("s\n", iss_debug);
             StringToIss("_cpu\n", iss_debug);
             sprintf( stemp, "%x\n", ncpu );
             StringToIss( stemp, iss_debug );
             DEPolis::break_inserted = 1;

             // Set breakpoint in ptl_sync
             fprintf(stderr, "DEPolis: breakname opened\n");
             DEPolis::breakname = fopen( brkname, "r" );
             DEPolis::num_break_inserted=0;
             StringToIss("s\n", iss_debug);
             sprintf( stemp, "%d\n", DEPolis::num_break_inserted );
             StringToIss( stemp, iss_debug );
             StringToIss("_ptl_sync\n", iss_debug);
             DEPolis::num_break_inserted++;
             fclose(DEPolis::breakname);
          }

          // Set breakpoints in the current module
          DEPolis::breakname = fopen( brkname, "r" );
          while (fgets(stemp, BUFSIZE, DEPolis::breakname) != NULL) {
             sscanf(stemp,"%s\t%s", model_name, brk_name);
             StringToIss("s\n", iss_debug);
             sprintf( stemp, "%d\n", DEPolis::num_break_inserted );
             StringToIss( stemp, iss_debug );
             sprintf( stemp, "_%s\n", brk_name );
             StringToIss( stemp, iss_debug );
             DEPolis::num_break_inserted++;
          }
          fclose(DEPolis::breakname);
       }
}


void DEPolis::StringToIss ( char *command, int iss_debug )
{
# line 652 "DEPolis.pl"
fprintf(DEPolis::toCommand,"%s", command); 
       fflush(DEPolis::toCommand);
       if ( iss_debug ) {
          fprintf(DEPolis::isslog,"%s", command); 
          fflush(DEPolis::isslog);
       }
}


void DEPolis::StringFromIss ( char *fromcommand )
{
# line 667 "DEPolis.pl"
fromcommand[0] = '\0';
       fgets(fromcommand,BUFSIZE,fromCommand);
}


void DEPolis::StringToIsslog ( char *command )
{
# line 678 "DEPolis.pl"
fprintf(DEPolis::isslog,"%s", command); 
       fflush(DEPolis::isslog);
}


void DEPolis::StartupIssCycles ( int cycles)
{
# line 689 "DEPolis.pl"
fprintf( stderr, "StartupIssCycles begin\n" );
       DEPolis::prev_cycles = cycles;
       fprintf( stderr, "StartupIssCycles end\n" );
}


void DEPolis::StoreIssCycles ( int cycles, int cached_delay )
{
# line 701 "DEPolis.pl"
if (!cached_delay) {
          DEPolis::delay = cycles - DEPolis::prev_cycles;
          DEPolis::prev_cycles = cycles;
       } else {
          DEPolis::delay = cycles;
       }
       DEPolis::ptl_cycles += DEPolis::delay;
}


void DEPolis::StartupIssEnergy ( double energy )
{
# line 717 "DEPolis.pl"
DEPolis::prev_energy = energy;
}


void DEPolis::StoreIssEnergy ( double energy, int cached_energy )
{
# line 727 "DEPolis.pl"
if (!cached_energy) {
          DEPolis::energy = energy - DEPolis::prev_energy;
       }
       else {
          DEPolis::energy = energy;
       }
       DEPolis::ptl_energy += DEPolis::energy;
       DEPolis::prev_energy = energy;
}


int DEPolis::GetIssCycles ()
{
# line 743 "DEPolis.pl"
return (DEPolis::delay);
}


double DEPolis::GetIssEnergy ()
{
# line 752 "DEPolis.pl"
return (DEPolis::energy);
}


void DEPolis::AddEnergy ( double value )
{
# line 762 "DEPolis.pl"
DEPolis::energy += value;
}


void DEPolis::runIss ( char *execname, char *cpuname )
{
# line 772 "DEPolis.pl"
char *argv[]={(char *) 0};

       if ( DEPolis::toCommand==NULL ) {
          if (!Pipefork(argv,&DEPolis::toCommand,&DEPolis::fromCommand,&DEPolis::iss_pid,execname,cpuname)) {
             fprintf(stderr, "Error in pipefork\n");
          }
          setbuf(toCommand,NULL);
          setbuf(stdout,NULL);
       }
}


void DEPolis::InitSis ()
{
# line 793 "DEPolis.pl"
#ifdef LINK_SIS
        cur_vector = LS_NIL; 
        input_names = LS_NIL; 
        vector_number = 0; 
        init_polis();
        fprintf( stderr, "InitSis\n" );
#endif /* LINK_SIS */
}


void DEPolis::EndSis ()
{
# line 808 "DEPolis.pl"
#ifdef LINK_SIS
        end_polis();
        fprintf( stderr, "EndSis\n" );
#endif /* LINK_SIS */
}


void DEPolis::ReadBlif ( char *blifname, network_t **ntwk )
{
# line 821 "DEPolis.pl"
#ifdef LINK_SIS
        FILE *bliffile;

        bliffile = fopen( blifname, "r" );
        if (( bliffile = fopen( blifname, "r" )) != NULL) { 
           read_blif( bliffile, ntwk );
        } 
        else {
          char stemp[ 1024 ];
          strcpy( stemp, blifname );
          strcat( stemp, ": file not existing" );
          Error::abortRun( stemp );
        }
//        write_blif( stdout, *ntwk, 0, 0 );
        fclose( bliffile );
#endif /* LINK_SIS */
}


void DEPolis::PowerCommandLineInterface ( network_t *ntwk, char *vecfile, float clkFreq )
{
# line 846 "DEPolis.pl"
#ifdef LINK_SIS
        char *power_argv[6];

        cur_vector = LS_NIL;
        input_names = LS_NIL;
        vector_number = 0;

        power_argv[0] = strdup( "power_estimate" );
        power_argv[1] = strdup( "-m" );
        power_argv[2] = strdup( "SAMPLING" );
        power_argv[3] = strdup( vecfile );
        power_argv[4] = strdup( "-c" );
        // power_argv[5] = strdup( "20.0" );
        fprintf( stderr, "PowerCommandLineInterface: clkFreq= %f\n", clkFreq ); 
        power_argv[5] = ALLOC( char, 20 );
        sprintf( power_argv[5], "%f", clkFreq ); 
        power_command_line_interface( ntwk, 6, power_argv );
        for ( int i=0; i<6; i++ ) {
           FREE( power_argv[i] );
        } 
#endif /* LINK_SIS */
}


void DEPolis::ConvBitVector ( char *buf, int arg, int size )
{
# line 876 "DEPolis.pl"
int i, temp;

       temp = arg;
       for (i=0; i<size; i++) {
          if ((temp%2) == 1) {
             strcat( buf, "1" );
          }
          else {
             strcat( buf, "0" );
          }
          if (temp>0) {
             temp = temp/2;
          }
          else {
             temp = (temp-1)/2; /* simulate ASR */
          }
       }
       strcat( buf, "\0" );
}


void DEPolis::InitCache ( int task_id, c_sg_node_t **sgraph, \
                 int cachesize, int linesize, int associativity, \
                 int historylength, float threshold, int csimulstyle, \
                 int i_fetch_size, int miss_penalty, int tracegenflag, \
                 char *module_name, int *numnodes )
{
# line 911 "DEPolis.pl"
#ifdef CACHE_SIMUL
       char root_dir[ 256 ];
       char stemp[1024]; 

       if ( ! DEPolis::cache_initialized ) {
          init_cache( cachesize, linesize, associativity, historylength, 
                      threshold, csimulstyle, 2 /* I_FETCHSIZE */, miss_penalty );
          DEPolis::cache_initialized = 1;
       }
       strcpy( root_dir, getenv("PTPWD") );
       if ( ! *sgraph ) {
          /* first simulation run */
          sprintf( stemp, "%s/z_%s_0", root_dir, module_name );
          build_sgraph( task_id, 0, 0, stemp );
          *sgraph = get_task_sgraph( get_task( task_id ));
          *numnodes = get_task_num_c_sg_nodes( get_task( task_id ));
       }
       else {
          /* following simulation runs */
          *numnodes = get_task_num_c_sg_nodes( get_task( task_id ));
          clean_hit_rate( *sgraph, *numnodes-1 );
          update_addresses( *sgraph, *numnodes, 0 );
       }
       if ( tracegenflag ) {
          sprintf( stemp, "%s/traces.txt", root_dir );
          OpenTraces( stemp );
       }
#endif /* CACHE_SIMUL */
}


void DEPolis::Compute_Abstract_Cache_State ( int task_id, int path_id, \
                 c_sg_node_t *sgraph, header_path_t **header_path, \
                 path_cache_layout_t **curr_layout, int is_SW, \
                 int csimulstyle, int csimulflag, int tracegenflag )
{
# line 951 "DEPolis.pl"
#ifdef CACHE_SIMUL
        compute_abstract_cache_state( task_id, path_id, sgraph, header_path, curr_layout, is_SW, csimulstyle, csimulflag, tracegenflag, DEPolis::fptraces );
#endif /* CACHE_SIMUL */
}


void DEPolis::Cache_Plot_Hit_Rate ( int task_id, c_sg_node_t *sgraph, \
                 header_path_t *header_path, int max_label, \
                 int is_SW, int csimulflag, int csimulstyle, \
                 XYPlot *xyplot, int plotgraph )
{
# line 966 "DEPolis.pl"
#ifdef CACHE_SIMUL

        // cache_plot_hit_rate( task_id, sgraph, header_path, max_label, is_SW, csimulflag, csimulstyle );

        int curr_node_id;
        c_sg_node_t *curr_node;

        if ( is_SW && csimulflag ) {
           if ( csimulstyle==FAST ) {
              curr_node_id = 0;
#ifdef DEBUG
              printf("CACHE_PLOT_HIT_RATE:\n");
              printf("\ttask_id= %d\n", task_id);
#endif
              while( curr_node_id <= max_label ) {
                 curr_node = get_node_sgraph( sgraph, curr_node_id );
#ifdef DEBUG
                 printf("\thit_rate(%d)= %.2f\tpath_vect(%d)= %d\n",
                        curr_node_id, get_hit_rate( curr_node ), curr_node_id,
                        get_path_vect_pos(header_path, curr_node_id));
#endif
#ifdef PTOLEMY
                 if ( plotgraph ) {
                    xyplot->addPoint( curr_node_id, get_hit_rate(curr_node), 1 );
                 }
#endif
                 curr_node_id++;
              }
           }
        }
#endif /* CACHE_SIMUL */
}


int DEPolis::Alloc_Header_Path ( int numnodes )
{
# line 1006 "DEPolis.pl"
#ifdef CACHE_SIMUL
        return( (int) alloc_header_path( numnodes ));
#endif /* CACHE_SIMUL */
}


void DEPolis::Add_Node_Path ( header_path_t *header_path, int node, \
                 int is_SW, int csimulflag )
{
# line 1019 "DEPolis.pl"
#ifdef CACHE_SIMUL
        add_node_in_path( header_path, node, is_SW, csimulflag );
#endif /* CACHE_SIMUL */
}


FILE * DEPolis::OpenTraces ( char *name )
{
# line 1031 "DEPolis.pl"
#ifdef CACHE_SIMUL
      if ( DEPolis::fptraces == NULL ) {
        DEPolis::fptraces = fopen( name, "w" );
        if ( DEPolis::fptraces ) {
          fprintf( DEPolis::fptraces, "Traces report\n\n" );
          fflush( DEPolis::fptraces );
        }
      }
      return( DEPolis::fptraces );
#endif /* CACHE_SIMUL */
}


double DEPolis::UpdateDelay_with_CacheInfo ()
{
# line 1049 "DEPolis.pl"
#ifdef CACHE_SIMUL
        double result;

        result = (double) ((n_instr_fetch_path - (int) n_instr_hit_path) * MISS_PENALTY);
        fprintf( stderr, "UpdateDelay_with_CacheInfo: _delay_cache= %f\n", result );
        return result;
#endif /* CACHE_SIMUL */
}


double DEPolis::FuzzyDelay ( char *fuzzy_expr )
{
# line 1069 "DEPolis.pl"
#ifdef USE_FUZZY
        return( (double) fuzzy_delay( fuzzy_expr )); 
#endif /* USE_FUZZY */
}


double DEPolis::FuzzyEnergy ( char *fuzzy_expr )
{
# line 1081 "DEPolis.pl"
#ifdef USE_FUZZY
        return( (double) fuzzy_energy( fuzzy_expr )); 
#endif /* USE_FUZZY */
}


int DEPolis::ReadCostParam ( char *cpu_name )
{
# line 1093 "DEPolis.pl"
#ifdef USE_FUZZY
        FILE *fp;
        char fname[ 1024 ];

        strcpy( fname, getenv("POLIS") );
        strcat( fname, "/polis_lib/estm/" );
        strcat( fname, cpu_name );
        strcat( fname, ".param" );
        if (( fp = fopen( fname, "r" )) != NULL) { 
           estm_free_estm_fncp(); 
           estm_read_param_file( fp );
           fclose( fp );
           return 0;
        }
        return -1;
#endif /* USE_FUZZY */
}


// prototype instance for known block list
static DEPolis proto;
static RegisterBlock registerBlock(proto,"Polis");
