#ifndef _DEPolis_h
#define _DEPolis_h 1
// header file generated from DEPolis.pl by ptlang

#ifdef __GNUG__
#pragma interface
#endif

#include "XYPlot.h"
#include "time.h"
#include "polis_sim.h"
#include "cache.h"
#include "DERCStar.h"

class DEPolis : public DERCStar
{
public:
	DEPolis();
	/* virtual */ Block* makeNew() const;
	/* virtual*/ const char* className() const;
	/* virtual*/ int isA(const char*) const;
	void resetAll ();
	int getImplem ( char *stimpl );
	FILE * Openoverflow ( char *name );
	void Printoverflow ( char *st );
	FILE * Openfiring ( char *name );
	void Printfiring ( char *st );
	void Closeflow ();
	int getincCounter ();
	int readPri ();
	double readNext ();
	int testCPU ( double now, int pri );
	int canRun ( int star_id );
	void saveContext ( int *opri, double *onxc, int *osrn, int pri );
	void setNewDelay ( double delay, int now, double *onxg );
	double interrupt ( double oldnextg );
	void restoreContext ( double newnextc, int oldpri, int oldstarrun );
	int scheduling ( int star_id, int star_pri, char *sched );
	void resetIss ();
	int Pipefork ( char **argv, FILE **toCommand, FILE **fromCommand, \
                 int *pid, char *execname, char *scpu );
	void initIss ( char *brkname, char *execname, char *scpu, \
                 char *root_dir, int ncpu, int iss_debug );
	void StringToIss ( char *command, int iss_debug );
	void StringFromIss ( char *fromcommand );
	void StringToIsslog ( char *command );
	void StartupIssCycles ( int cycles);
	void StoreIssCycles ( int cycles, int cached_delay );
	void StartupIssEnergy ( double energy );
	void StoreIssEnergy ( double energy, int cached_energy );
	int GetIssCycles ();
	double GetIssEnergy ();
	void AddEnergy ( double value );
	void runIss ( char *execname, char *cpuname );
	void InitSis ();
	void EndSis ();
	void ReadBlif ( char *blifname, network_t **ntwk );
	void PowerCommandLineInterface ( network_t *ntwk, char *vecfile, float clkFreq );
	void ConvBitVector ( char *buf, int arg, int size );
	void InitCache ( int task_id, c_sg_node_t **sgraph, \
                 int cachesize, int linesize, int associativity, \
                 int historylength, float threshold, int csimulstyle, \
                 int i_fetch_size, int miss_penalty, int tracegenflag, \
                 char *module_name, int *numnodes );
	void Compute_Abstract_Cache_State ( int task_id, int path_id, \
                 c_sg_node_t *sgraph, header_path_t **header_path, \
                 path_cache_layout_t **curr_layout, int is_SW, \
                 int csimulstyle, int csimulflag, int tracegenflag );
	void Cache_Plot_Hit_Rate ( int task_id, c_sg_node_t *sgraph, \
                 header_path_t *header_path, int max_label, \
                 int is_SW, int csimulflag, int csimulstyle, \
                 XYPlot *xyplot, int plotgraph );
	int Alloc_Header_Path ( int numnodes );
	void Add_Node_Path ( header_path_t *header_path, int node, \
                 int is_SW, int csimulflag );
	FILE * OpenTraces ( char *name );
	double UpdateDelay_with_CacheInfo ();
	double FuzzyDelay ( char *fuzzy_expr );
	double FuzzyEnergy ( char *fuzzy_expr );
	int ReadCostParam ( char *cpu_name );

protected:
# line 12 "DEPolis.pl"
static int  counter;
    static int  priority_pol;
    static int  priority_next;
    static double  next_curr;
    static double  next_glob;
    static int  star_ack;
    static int  star_run;
    static FILE *fpoverflow;
    static FILE *fpfiring;

    static FILE *fromCommand;
    static FILE *toCommand;
    static FILE *breakname;
    static FILE *isslog;
    static FILE *fptraces;
    static int iss_pid;
    static int break_inserted;
    static int prev_cycles;
    static int ptl_cycles;
    static double prev_energy;
    static double ptl_energy;
    static int delay;
    static double energy;
    static double MinTime;
    static double MaxTime;
    static double MinEnergy;
    static double MaxEnergy;
    static double xMinPower;
    static double xMaxPower;
    static double MinPower;
    static double MaxPower;
    static int xyplotEnergy_created;
    static XYPlot xyplotEnergy;
    static int xyplotPower_created;
    static XYPlot xyplotPower;
    static int num_break_inserted;
    static clock_t simCpuTime;     // in order to measure elapsed delays
    static int cache_initialized;

};
#endif
