defstar {
    name { dpmemory }
    domain { DE }
    desc { Polis double port memory }
    author { Claudio Passerone }
    input { 
        name { RESET }
        type { int }
        desc { Reset memory (does not initialize it) }
    }
    input {
        name { WRITE_ADDR }
        type { int }
        desc { Write address (waits for data) }
    }
    input {
        name { READ_ADDR }
        type { int }
        desc { Read address (immediate) }
    }
    input {
        name { DATA_IN }
        type { int }
        desc { Write data (wait for address) }
    }
    output {
        name { DATA_OUT }
        type { int }
        desc { Read data }
    }
    state {
        name { memsize }
        type { int }
        default { "1" }
        desc { Memory size (in number of int values) }
    }
    private {
        int * data;
    }
    constructor {
        delayType = TRUE;
    }
    begin {
        char stemp[ 1024 ];
		extern void * calloc (int, int);
        if (( data = (int *) calloc( sizeof( int ), memsize )) == NULL ) {
            strcpy( stemp, "Cannot allocate memory" );
            Error::abortRun( *this, stemp );
        }
    }
    go {
        int addr, val;
        char stemp[ 1024 ];
        
        if ( RESET.dataNew ) {
            while ( RESET.dataNew ) RESET.getSimulEvent();
            while ( READ_ADDR.dataNew ) READ_ADDR.getSimulEvent();
            while ( WRITE_ADDR.dataNew ) WRITE_ADDR.getSimulEvent();
            while ( DATA_IN.dataNew ) DATA_IN.getSimulEvent();
        } else {
            if ( READ_ADDR.dataNew ) {
                addr = (READ_ADDR)%0;
                while ( READ_ADDR.dataNew ) READ_ADDR.getSimulEvent();
                if ( addr < 0 || addr > memsize - 1 ) {
                    sprintf( stemp, "Read out of bound at memory address %d", addr );
                    Error::abortRun( *this, stemp );
                }   
                val = data[ addr ];
                DATA_OUT.put( arrivalTime + 1.0 ) << val;
            }
            if ( WRITE_ADDR.dataNew ) {
                if ( DATA_IN.dataNew ) {
                    addr = (WRITE_ADDR)%0;
                    val = (DATA_IN)%0;
                    while ( WRITE_ADDR.dataNew ) WRITE_ADDR.getSimulEvent();
                    while ( DATA_IN.dataNew ) DATA_IN.getSimulEvent();
                    if ( addr < 0 || addr > memsize - 1 ) {
                        sprintf( stemp, "Write out of bound at memory address %d", addr );
                        Error::abortRun( *this, stemp );
                    }
                    data[ addr ] = val;
                }
            }
        }
    }
}
