defstar {
    name {measure_dc}
    derivedfrom {RepeatStar}
    domain {DE}
    author {Claudio Passerone}
    desc {Measure the DC value of a PWM signal.}
    input {
        name {IN}
        type {int}
    }
    output {
        name {OUT}
        type {int}
    }
    state {
        name {CONST_NORMALIZE}
        type {int}
        default {NORMALIZE}
        desc {Normalization constant}
    }
    private {
        int val;
        int waitone;
        double startone;
        double startzero;
        double now;
        int mean;
    }
    begin {
        waitone = 1;
        startone = 0;
        startzero = 0;
    }
    go {
        now = arrivalTime;
        if ( IN.dataNew ) {
            val = (IN)%0;
            if ( waitone == 1 && val != 0 ) {
                if ( startone != 0 && startzero != 0 ) {
                    mean = (( startzero - startone ) / ( now - startone )) * 
                           (int) CONST_NORMALIZE - ((int) CONST_NORMALIZE / 2 );
                    OUT.put( now ) << mean;
                } else if ( startone == 0 && startzero != 0 ) {
                    OUT.put( now ) << 0;
                }
                startone = now;
                startzero = 0;
                waitone = 0;
            } else if ( waitone == 1 && val == 0 ) {
                if ( startone != 0 && startzero != 0 ) {
                    mean = (( startzero - startone ) / ( now - startone )) * 
                           (int) CONST_NORMALIZE - ((int) CONST_NORMALIZE / 2 );
                    OUT.put( now ) << mean;
                } else if ( startone == 0 && startzero != 0 ) {
                    OUT.put( now ) << 0;
                }
                startone = now;
                startzero = now;
                waitone = 1;
            } else if ( waitone == 0 && val == 0 ) {
                startzero = now;
                waitone = 1;
            } else {
                /* What the heck ???  */
            }
        }
    }
}
            
            
    
