defstar {
	name { Absclock }
	derivedFrom { RepeatStar }
	domain { DE }
	author { Claudio Passerone }
	desc { Generate events every x milliseconds, starting at time zero.
               Need a universe parameter called Clock_freq, in Mhz. }
	output {
		name { output }
		type { float }
	}
	defstate {
		name { interval }
		type { float }
		default { "1.0" }
		desc { The interval of events, in milliseconds. }
	}
	defstate {
		name { magnitude }
		type { float }
		default { "1.0" }
		desc { The value of the output particles generated. }
	}
	defstate {
		name { frequency }
		type { float }
		default { "Clock_freq" }
		desc { Clock frequency of the processor }
		attributes { A_NONSETTABLE }
	}
	go {
	   // Generate the output event
	   // (Recall that the first event comes out at time 0).
	   output.put( completionTime ) << double( magnitude );

	   // and schedule the next firing
	   completionTime += interval * frequency * 1000;
	   refireAtTime((int) completionTime );
	}
}
