/*************************************************************************

  Copyright   [Copyright (c) 1994-1996 The Regents of the Univ. of California.
  All rights reserved.

  Permission is hereby granted, without written agreement and without license
  or royalty fees, to use, copy, modify, and distribute this software and its
  documentation for any purpose, provided that the above copyright notice and
  the following two paragraphs appear in all copies of this software.

  IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY FOR
  DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
  OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF THE UNIVERSITY OF
  CALIFORNIA HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

  THE UNIVERSITY OF CALIFORNIA SPECIFICALLY DISCLAIMS ANY WARRANTIES,
  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
  FITNESS FOR A PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS ON AN
  "AS IS" BASIS, AND THE UNIVERSITY OF CALIFORNIA HAS NO OBLIGATION TO PROVIDE
  MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.]

******************************************************************************/
/* Controls the 68HC11 A/D converter.
#ifdef MULT
 * This file was compiled to work in multi-channel mode
#endif
#ifdef SCAN
 * This file was compiled to work in continuous scan mode
#endif
 */

void init_ad@ ()
{
#ifdef SCAN
	_r_h11adctl.bit.b5 = 1;
#else
	_r_h11adctl.bit.b5 = 0;
#endif /*SCAN*/
#ifdef MULT
	_r_h11adctl.bit.b4 = 1;
#else
	_r_h11adctl.bit.b4 = 0;
#endif /*MULT*/
	_r_h11adctl.nibble.n0 = 0;
}

void deliver_e_AD_START_to_ad@ ()
{
	_r_h11adctl.nibble.n0 = v_AD_START;
	_r_h11adctl = _r_h11adctl;
}

/* (should be inlined once we find out how to rename them according to
 * parameter passing)
 */

void deliver_e_ECLK_to_ad@() { }

int got_inp_event_e_AD_END ()
{
	return _r_h11adctl.bit.b7 != 0;
}

#ifdef v_ADR1
#undef v_ADR1
#endif
#define v_ADR1 _r_h11adr1;
#ifdef v_ADR2
#undef v_ADR2
#endif
#define v_ADR2 _r_h11adr2;
#ifdef v_ADR3
#undef v_ADR3
#endif
#define v_ADR3 _r_h11adr3;
#ifdef v_ADR4
#undef v_ADR4
#endif
#define v_ADR4 _r_h11adr4;
