/*************************************************************************

  Copyright   [Copyright (c) 1994-1996 The Regents of the Univ. of California.
  All rights reserved.

  Permission is hereby granted, without written agreement and without license
  or royalty fees, to use, copy, modify, and distribute this software and its
  documentation for any purpose, provided that the above copyright notice and
  the following two paragraphs appear in all copies of this software.

  IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY FOR
  DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
  OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF THE UNIVERSITY OF
  CALIFORNIA HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

  THE UNIVERSITY OF CALIFORNIA SPECIFICALLY DISCLAIMS ANY WARRANTIES,
  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
  FITNESS FOR A PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS ON AN
  "AS IS" BASIS, AND THE UNIVERSITY OF CALIFORNIA HAS NO OBLIGATION TO PROVIDE
  MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.]

******************************************************************************/

/* Uses ic to implement input capture.
 */

#if (v_N == 1)
#define local_init
#define intr_enable _r_h11tmsk1.bit.b2
#define edge1 _r_h11tctl2.bit.b5
#define edge2 _r_h11tctl2.bit.b4
#define ic_flag _r_h11tflg1.bit.b2
#define ic_cap _r_h11tic1
#define IC_VEC IC1_VEC
#else
#if (v_N == 2)
#define local_init 
#define intr_enable _r_h11tmsk1.bit.b1
#define edge1 _r_h11tctl2.bit.b3
#define edge2 _r_h11tctl2.bit.b2
#define ic_flag _r_h11tflg1.bit.b1
#define ic_cap _r_h11tic2
#define IC_VEC IC2_VEC
#else
#if (v_N == 3)
#define local_init
#define intr_enable _r_h11tmsk1.bit.b0
#define edge1 _r_h11tctl2.bit.b1
#define edge2 _r_h11tctl2.bit.b0
#define ic_flag _r_h11tflg1.bit.b0
#define ic_cap _r_h11tic3
#define IC_VEC IC3_VEC
#else
#if (v_N == 4)
#define local_init _r_h11pactl.bit.b2 = 1;
#define intr_enable _r_h11tmsk1.bit.b3
#define edge1 _r_h11tctl2.bit.b7
#define edge2 _r_h11tctl2.bit.b6
#define ic_flag _r_h11tflg1.bit.b3
#define ic_cap _r_h11ti4o5
#define IC_VEC IC4_VEC
#else
invalid_ic_number_selected_will_cause_syntax_error;
#endif
#endif
#endif
#endif

/****************************************************************************
 * Initialization section
 */
void init_ic ()
{
#ifndef e_o_IC_END_POLLED
	extern __IT_type IT_handle_e_IC_END ();
#ifdef EMULATOR
	extern void _VECTOR(void (* func)(void), int _VECTOR);
	_VECTOR (IT_handle_e_IC_END, IC_VEC);
#endif
#endif /*e_o_IC_END_POLLED*/

	/* set oc5/ic4 to ic4 */
	local_init

	/* capture on rising edge */
	edge1 = 0;
	edge2 = 1;

#ifndef e_o_IC_END_POLLED
	/* intr enable */
	intr_enable = 1;
#endif /*e_o_IC_END_POLLED*/

}

/****************************************************************************
 * Dummy event detection section
 * (should be inlined once we find out how to rename them according to
 * parameter passing)
 *void deliver_e_IC_START_to_ic() { }
 *void deliver_e_TCLK_to_ic() { }
 */

/****************************************************************************
 * IC_END emission section
 */

#ifdef e_o_IC_END_POLLED
int got_inp_event_e_o_IC_END ()
#else
__IT_type IT_handle_e_o_IC_END ()
#endif /*e_o_IC_END_POLLED*/
{
#ifdef e_o_IC_END_POLLED
	if (ic_flag) {
#else
	/* intr disable */
	intr_enable = 0;
#endif /*e_o_IC_END_POLLED*/
	/* funny way to clear a flag... */
		ic_flag = 1;
		v_o_IC_END = ic_cap;
		emit_e_o_IC_END ();
#ifdef e_o_IC_END_POLLED
		return 1;
	}
	return 0;
#else
	/* intr enable */
	intr_enable = 1;
#endif /*e_o_IC_END_POLLED*/
}

#undef local_init
#undef intr_enable
#undef edge1
#undef edge2
#undef ic_flag
#undef ic_cap
#undef IC_VEC
/****************************************************************************
 * end
 */
