/*************************************************************************

  Copyright   [Copyright (c) 1994-1996 The Regents of the Univ. of California.
  All rights reserved.

  Permission is hereby granted, without written agreement and without license
  or royalty fees, to use, copy, modify, and distribute this software and its
  documentation for any purpose, provided that the above copyright notice and
  the following two paragraphs appear in all copies of this software.

  IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY FOR
  DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
  OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF THE UNIVERSITY OF
  CALIFORNIA HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

  THE UNIVERSITY OF CALIFORNIA SPECIFICALLY DISCLAIMS ANY WARRANTIES,
  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
  FITNESS FOR A PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS ON AN
  "AS IS" BASIS, AND THE UNIVERSITY OF CALIFORNIA HAS NO OBLIGATION TO PROVIDE
  MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.]

******************************************************************************/
/* programs the PWMCLK as defined by the PWMPRESCALER constant TIMES TWO
 * (to include the 2 * ECLK case)
 * Assumes that ECLK and PWMCLK are top-level events in the system netlist
 * (i.e., they keep their names...)
 */
#if (v_SIMSCALE != 0)
    simscale_must_be_0 otherwise_syntax_error;
#endif

/****************************************************************************
 * State variable section
 */

/****************************************************************************
 * Initialization section
 */
void init_pwmfrc ()
{
#if (v_PWMPRESCALER == 1)
	_r_h11pwck.bit.b4 = 0;
	_r_h11pwck.bit.b5 = 0;
#else
#if (v_PWMPRESCALER == 2)
	_r_h11pwck.bit.b4 = 1;
	_r_h11pwck.bit.b5 = 0;
#else
#if (v_PWMPRESCALER == 4)
	_r_h11pwck.bit.b4 = 0;
	_r_h11pwck.bit.b5 = 1;
#else
#if (v_PWMPRESCALER == 8)
	_r_h11pwck.bit.b4 = 1;
	_r_h11pwck.bit.b5 = 1;
#else
	invalid_prescale_factor_selected cause_syntax_error; 
#endif
#endif
#endif
#endif

	/* disable interrupts */
	_r_h11pwck.bit.b0 = 0;
}

/****************************************************************************
 * Dummy event detection and emission section
 * (should be inlined once we find out how to rename them according to
 * parameter passing)
 *void deliver_e_ECLK_to_pwmfrc () {}
 *int got_inp_event_e_PWMCLK () { return 1; } 
 */

/****************************************************************************
 * end
 */
